/*===========================================================================
/
/									ttPage
/								t@C̕ҏW
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <windowsx.h>
#include <tchar.h>

#include "resource.h"
#include "common.h"


/*===== vg^Cv =====*/

static LPTSTR MakeCommandLine(FILEMANTBL *tbl);
static LPTSTR GetToolEncodeOption(FILEMANTBL *tbl);
static int SetEditWaitTable(HANDLE hProc, HWND hWnd, int endMsg, WPARAM wParam, LPARAM lParam);
static void EraseEditWaitTable(EDITWAIT *del);
static void CALLBACK EditWaitProc(HWND hWnd, UINT msg, UINT timerId, DWORD time);

/*===== [Jȃ[N =====*/

static UINT EditTimer = 0;
static EDITWAIT *EwaitTop = NULL;


/*-------------------------------------------------------------------------------
Name    :	ExecEditor
Desc    :	GfB^ic[jN
Param   :	tbl			t@CǗe[u
			hWndPar		eEChẼEChEnh
			endMsg		ҏWIɐeEChEɑ郁bZ[W
			wParam		ҏWĨbZ[WwParaml
			lParam		ҏWĨbZ[WlParaml
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void ExecEditor(FILEMANTBL *tbl, HWND hWndPar, int endMsg, WPARAM wParam, LPARAM lParam)
{
	PROCESS_INFORMATION	processInfo;
	STARTUPINFO			startup;
	LPTSTR				comLine;
	int					wait;
	int					sts;
	SHELLEXECUTEINFO	shellInfo;
	HANDLE				hProcess;
	EXTSET				*extSet = AskCurExtSet();

	comLine = NULL;
	sts = FAIL;

#if 0
/*Ȃ*/
	if((EditSjisAlways == YES) && (tbl->Kanji != ENCODE_SJIS))
	{
		Open = NULL;
		if(SelectFileToSave(GetMainHwnd(), filename, _T("SHIFT-JISR[hŕۑ"), _T("")) == TRUE)
		{

/* UTF16ΏۃGR[hɕϊ */

			if((Strm = _tfopen(filename, _T("wt"))) != NULL)
			{
				fwrite(tbl->TextData, tbl->TextSize, 1, Strm);
				fclose(Strm);
				Open = filename;
			}
		}
	}
#endif

	if(tbl->Fname != NULL)
	{
		if(extSet->ToolType == TOOL_TYPE_ASSOC)
		{
			/* ֘AtꂽAvN */
			shellInfo.cbSize = sizeof(SHELLEXECUTEINFO);
			shellInfo.fMask = SEE_MASK_NOCLOSEPROCESS;
			shellInfo.hwnd = NULL;
			shellInfo.lpVerb = _T("open");
			shellInfo.lpFile = tbl->Fname;
			shellInfo.lpParameters = _T("");;
			shellInfo.lpDirectory = _T(".");
			shellInfo.nShow = SW_SHOW;
			if(ShellExecuteEx(&shellInfo))
			{
				hProcess = shellInfo.hProcess;
				sts = SUCCESS;
			}
		}
		else
		{
			/* w肳ꂽAvN */
			comLine = MakeCommandLine(tbl);
			if(comLine != NULL)
			{
				memset(&startup, NUL, sizeof(STARTUPINFO));
				startup.cb = sizeof(STARTUPINFO);
				startup.wShowWindow = SW_SHOW;
				if(CreateProcess(NULL, comLine, NULL, NULL, FALSE, 0, NULL, NULL, &startup, &processInfo) == FALSE)
				{
					MessageBox(hWndPar, comLine, MSGJPN_3, MB_ICONSTOP | MB_OK);
				}
				else
				{
					hProcess = processInfo.hProcess;
					sts = SUCCESS;
				}
				free(comLine);
			}
		}

		if(sts == SUCCESS)
		{
			/* AvN̏ */
			if(extSet->EditAndClose == YES)
			{
				/* ttPageI */
				PostMessage(GetMainHwnd(), WM_CLOSE, 0, 0L);
			}
			else if(extSet->EditAutoReLoad == YES)
			{
				/* AvI҂ɂ */
				wait = AskEditWait();
				if(SetEditWaitTable(hProcess, hWndPar, endMsg, wParam, lParam) == SUCCESS)
				{
					if(wait == NO)
					{
						EditTimer = SetTimer(GetMainHwnd(), TIMER_EDITWAIT, 500, EditWaitProc);
					}
				}
			}
		}
	}
	else
	{
		MessageBox(hWndPar, MSGJPN_4, MSGJPN_3, MB_ICONSTOP | MB_OK);
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	MakeCommandLine
Desc    :	GfB^Np̃R}hC쐬
Param   :	tbl			t@CǗe[u
Return  :	R}hC
Note    :	
-------------------------------------------------------------------------------*/
static LPTSTR MakeCommandLine(FILEMANTBL *tbl)
{
	LPTSTR	buf;
	LPTSTR	ret;
	int		num;
	LPTSTR	tool;
	LPTSTR	filename;
	LPTSTR	option;
	EXTSET	*extSet = AskCurExtSet();

	tool = extSet->EditorName;
	filename = tbl->Fname;
	option = GetToolEncodeOption(tbl);

	ret = NULL;

	num = tbl->DispTopLine + 1;
	if(extSet->LineNumType == LINENUM_EDITOR)
	{
		num = GetLogicalLineNum(tbl, tbl->DispTopLine) + 1;
	}

	buf = Malloc((_tcslen(tool) + _tcslen(filename) + _tcslen(option) + 10 + 2 + 1) * sizeof(_TCHAR));
	if(buf != NULL)
	{
		ret = buf;
		while(*tool != NUL)
		{
			if(*tool == _T('$'))
			{
				tool++;
				if(*tool == NUL)
				{
					break;
				}
				if(*tool == _T('$'))
				{
					*buf++ = _T('$');
				}
				else if(_totupper(*tool) == _T('F'))
				{
					if(_tcschr(filename, _T(' ')) != NULL)
					{
						*buf++ = 0x22;		/* _uNI[g */
					}
					_tcscpy(buf, filename);
					buf = _tcschr(buf, NUL);
					if(_tcschr(filename, _T(' ')) != NULL)
					{
						*buf++ = 0x22;		/* _uNI[g */
					}
				}
				else if(_totupper(*tool) == _T('L'))
				{
					_stprintf(buf, _T("%d"), num);
					buf = _tcschr(buf, NUL);
				}
				else if(_totupper(*tool) == _T('K'))
				{
					_tcscpy(buf, option);
					buf = _tcschr(buf, NUL);
				}
				tool++;
			}
			else
			{
				*buf++ = *tool++;
			}
		}
		*buf = NUL;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetToolEncodeOption
Desc    :	GR[hƂ̃IvV擾
Param   :	tbl			t@CǗe[u
Return  :	IvV
Note    :	
-------------------------------------------------------------------------------*/
static LPTSTR GetToolEncodeOption(FILEMANTBL *tbl)
{
	EXTSET	*extSet = AskCurExtSet();
	LPTSTR	ret;

	ret = _T("");
	switch(tbl->Encoding)
	{
		case ENCODE_SJIS :
			ret = extSet->EditOptSJIS;
			break;

		case ENCODE_EUC :
			ret = extSet->EditOptEUC;
			break;

		case ENCODE_JIS :
			ret = extSet->EditOptJIS;
			break;

		case ENCODE_UTF16_BOM :
		case ENCODE_UTF16_NOBOM :
			ret = extSet->EditOptUTF16;
			break;

		case ENCODE_UTF16_BOM_BE :
		case ENCODE_UTF16_NOBOM_BE :
			ret = extSet->EditOptUTF16BE;
			break;

		case ENCODE_UTF8_BOM :
		case ENCODE_UTF8_NOBOM :
			ret = extSet->EditOptUTF8;
			break;

		case ENCODE_UTF7_NOBOM :
			ret = extSet->EditOptUTF7;
			break;

		default :
			break;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	AskEditWait
Desc    :	I҂ɂȂĂ邩ǂԂ
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
int AskEditWait(void)
{
	int		ret;

	ret = NO;
	if(EwaitTop != NULL)
	{
		ret = YES;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	ExitAllEditor
Desc    :	SĂ̏I҂
Param   :	sendMsg		GfB^IbZ[W𑗂邩ǂ (YES/NO)
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int ExitAllEditor(int sendMsg)
{
	if(EditTimer != 0)
	{
		KillTimer(GetMainHwnd(), EditTimer);
	}
	EditTimer = 0;

	while(EwaitTop != NULL)
	{
		if(sendMsg == YES)
		{
			PostMessage(EwaitTop->hWnd, EwaitTop->EndMesg, EwaitTop->wParam, EwaitTop->lParam);
		}
		EraseEditWaitTable(EwaitTop);
	}
	return(SUCCESS);
}


/*-------------------------------------------------------------------------------
Name    :	SetEditWaitTable
Desc    :	GfB^I҂f[^e[u쐬
Param   :	hProc		vZXnh
			hWnd		IɃbZ[W𑗂EChEnh
			endMsg		Iɑ郁bZ[W
			wParam		Iɑ郁bZ[WwParaml
			lParam		Iɑ郁bZ[WlParaml
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
static int SetEditWaitTable(HANDLE hProc, HWND hWnd, int endMsg, WPARAM wParam, LPARAM lParam)
{
	EDITWAIT	*pos;
	EDITWAIT	*prev;

	pos = Malloc(sizeof(EDITWAIT));
	if(EwaitTop == NULL)
	{
		EwaitTop = pos;
	}
	else
	{
		prev = EwaitTop;
		while(prev->Next != NULL)
		{
			prev = prev->Next;
		}
		prev->Next = pos;
	}

	pos->hProc = hProc;
	pos->hWnd = hWnd;
	pos->EndMesg = endMsg;
	pos->wParam = wParam;
	pos->lParam = lParam;
	pos->Next = NULL;

	return(SUCCESS);
}


/*-------------------------------------------------------------------------------
Name    :	EraseEditWaitTable
Desc    :	GfB^I҂f[^폜
Param   :	del		폜GfB^I҂f[^
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void EraseEditWaitTable(EDITWAIT *del)
{
	EDITWAIT	*pos;
	EDITWAIT	*prev;

	prev = NULL;
	pos = EwaitTop;
	while(pos != NULL)
	{
		if(pos == del)
		{
			if(prev == NULL)
			{
				EwaitTop = pos->Next;
			}
			else
			{
				prev->Next = pos->Next;
			}
			free(pos);
			break;
		}
		prev = pos;
		pos = pos->Next;
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	EditWaitProc
Desc    :	GfB^I҂R[obN֐
Param   :	hWnd		^C}bZ[W̃EChEnh
			msg			WM_TIMERbZ[W
			timerId		^C}hc
			time		݂̃VXe
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void CALLBACK EditWaitProc(HWND hWnd, UINT msg, UINT timerId, DWORD time)
{
	EDITWAIT	*pos;
	DWORD		ret;

	KillTimer(hWnd, EditTimer);
	EditTimer = 0;
	pos = EwaitTop;
	while(pos != NULL)
	{
		GetExitCodeProcess(pos->hProc, &ret);
		if(ret != STILL_ACTIVE)
		{
			PostMessage(pos->hWnd, pos->EndMesg, pos->wParam, pos->lParam);
			EraseEditWaitTable(pos);
			break;
		}
		pos = pos->Next;
	}

	if(AskEditWait() == YES)
	{
		EditTimer = SetTimer(hWnd, timerId, 500, EditWaitProc);
	}
	return;
}


