/*===========================================================================
/
/									ttPage
/								f[^e[u
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define HAVE_ONIGURUMA

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <shlobj.h>
#include <tchar.h>

#include "common.h"
#include "resource.h"
#include "oniguruma.h"

/*===== vg^Cv =====*/

static LPTSTR MakeOneLineSubNum(HDC hDC, LPTSTR text, LPTSTR btm, int tabWidth, int fold, int *lineNum);
static LPTSTR MakeOneLineSubRitht(HDC hDC, LPTSTR text, LPTSTR btm, int tabWidth, int width, int *lineNum);
static LPTSTR GetLineTopFromAdrs(FILEMANTBL *tbl, LPTSTR text);
static int GetLineNumFromAdrs(FILEMANTBL *tbl, LPTSTR text);
static int ConvLineToTableAndIndex(FILEMANTBL *tbl, int num, LINETOPTBL **cur, int *index);
static void MoveToNextTableAndIndex(LINETOPTBL **cur, int *index);
static int AskCharacterType(LPTSTR text);

/*===== [Jȃ[N ======*/

static FILEMANTBL *FileTblTop = NULL;
static int CurrentFile = -1;
static FILEMANTBL *CurrentTbl = NULL;

/*===== O[oȃ[N ======*/

//extern int lineNum;
extern HFONT hFontttPage;
extern int CharCellWidth;


/*-------------------------------------------------------------------------------
Name    :	MakeLineTopTbl
Desc    :	eLXgŜɂčs擪ʒuf[^쐬
Param   :	tbl		t@CǗf[^
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	s擪ʒuf[^ɂ́A܂܂
			j	lineTop[0] = _T("line 1\n")		Ps
					lineTop[1] = _T("Line 2\n")		Qs
					lineTop[2] = _T("")				
					lines = 2
-------------------------------------------------------------------------------*/
int MakeLineTopTbl(FILEMANTBL *tbl)
{
	LINETOPTBL	*pos;
	LINETOPTBL	*prev;
	int			index;
	LPTSTR		text;
	LPTSTR		btm;
	int			sts;
	int			fold;
	int			tab;
	int			lineNum;
	HDC			hDC;
	HWND		hWnd;
	HFONT		hFontOld;
	RECT		rect;

	sts = SUCCESS;

	RemoveLineTopTbl(tbl);
	fold = AskCurExtSet()->FoldPos;
	tab = AskCurExtSet()->TabWidth;

	hWnd = GetViewWinHwnd();
	hDC = GetDC(hWnd);
	hFontOld = NULL;
	if(hFontttPage != NULL)
	{
		hFontOld = SelectObject(hDC, hFontttPage);
	}
	GetClientRect(hWnd, &rect);

	text = tbl->TextData;
	btm = text + tbl->TextSize;
	lineNum = 0;
	do
	{
		if((pos = Malloc(sizeof(LINETOPTBL))) != NULL)
		{
			if(tbl->LineData == NULL)
			{
				tbl->LineData = pos;
			}
			else
			{
				prev->Next = pos;
			}

			prev = pos;
			pos->Next = NULL;
			pos->Lines = 0;
			for(index = 0; index < LINETBLMAX; index++)
			{
				pos->LineTop[index] = text;
				pos->LineNum[index] = lineNum;

				if(text >= btm)
				{
					text++;
					break;
				}

				pos->Lines += 1;
				tbl->TextLines += 1;

				if(AskCurExtSet()->FoldRight == NO)
				{
					text = MakeOneLineSubNum(hDC, text, btm, tab, fold, &lineNum);
				}
				else
				{
					text = MakeOneLineSubRitht(hDC, text, btm, tab, rect.right - (LEFT_OFFSET * 2), &lineNum);
				}
			}
		}
		else
		{
			sts = FAIL;
		}
	}
	while((sts == SUCCESS) && (text <= btm));

	tbl->SbarStep = (tbl->TextLines + 65535) / 65535;

	if(hFontOld != NULL)
	{
		SelectObject(hDC, hFontOld);
	}
	ReleaseDC(hWnd, hDC);

	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	MakeOneLineSubNum
Desc    :	܂ԂʒuwłPs쐬
Param   :	hDC			foCXReLXg
			text		eLXg
			btm			eLXg̖
			tabWidth	^u
			fold		܂Ԃʒu
			lineNum		sԍ
Return  :	s̃AhX
Note    :	
-------------------------------------------------------------------------------*/
static LPTSTR MakeOneLineSubNum(HDC hDC, LPTSTR text, LPTSTR btm, int tabWidth, int fold, int *lineNum)
{
	int		col;
	LPTSTR	orgTop;
	SIZE	size;

	orgTop = text;
	col = 0;
	while(text < btm)
	{
		if(*text == _T('\r'))
		{
			col += 1;
			if(col > fold)
			{
				break;
			}
			*lineNum += 1;
			text++;
			if((text < btm) && (*text == _T('\n')))
			{
				text++;
			}
			break;
		}
		else if(*text == _T('\n'))
		{
			col += 1;
			if(col > fold)
			{
				break;
			}
			*lineNum += 1;
			text++;
			break;
		}
		else if(*text == _T('\t'))
		{
			col += GetTabWidth(tabWidth, col);
			if(col > fold)
			{
				break;
			}
			text++;
		}
		else if(*text < _T(' '))
		{
			col += 1;
			if(col > fold)
			{
				break;
			}
			text++;
		}
		else
		{
	    	GetTextExtentPoint32(hDC, text, 1, &size);
			col += (size.cx + CharCellWidth - 1) / CharCellWidth;
			if(col > fold)
			{
				break;
			}
			text++;
		}
	}

	/* Ps͍ŒP */
	if(orgTop == text)
	{
		text++;
	}
	return(text);
}


/*-------------------------------------------------------------------------------
Name    :	MakeOneLineSubRitht
Desc    :	E[Ő܂ԂłPs쐬
Param   :	hDC			foCXReLXg
			text		eLXg
			btm			eLXg̖
			tabWidth	^u
			width		EChE̕
			lineNum		sԍ
Return  :	s̃AhX
Note    :	
-------------------------------------------------------------------------------*/
static LPTSTR MakeOneLineSubRitht(HDC hDC, LPTSTR text, LPTSTR btm, int tabWidth, int width, int *lineNum)
{
	int		tabs;
	int		col;
	int		posX;
	SIZE	size;
	LPTSTR	orgTop;

	posX = 0;
	col = 0;
	orgTop = text;

	while(text < btm)
	{
		if(*text == _T('\r'))
		{
			posX += CharCellWidth;
			if(posX > width)
			{
				break;
			}
			*lineNum += 1;
			text++;
			if((text < btm) && (*text == _T('\n')))
			{
				text++;
			}
			break;
		}
		else if(*text == _T('\n'))
		{
			posX += CharCellWidth;
			if(posX > width)
			{
				break;
			}
			*lineNum += 1;
			text++;
			break;
		}
		else if(*text == _T('\t'))
		{
			tabs = GetTabWidth(tabWidth, col);
			col += tabs;
			posX += tabs * CharCellWidth;
			if(posX > width)
			{
				break;
			}
			text++;
		}
		else if(*text < _T(' '))
		{
			col += 1;
			posX += CharCellWidth;
			if(posX > width)
			{
				break;
			}
			text++;
		}
		else
		{
			GetTextExtentPoint32(hDC, text, 1, &size);
			posX += size.cx;
			if(posX > width)
			{
				break;
			}
			text++;
		}
	}

	/* Ps͍ŒP */
	if(orgTop == text)
	{
		text++;
	}
	return(text);
}


/*-------------------------------------------------------------------------------
Name    :	GetTabWidth
Desc    :	݂̌ʒu玟̃^uXgbv܂ł̌Ԃ
Param   :	tabWidth	^u
			col			݂̌ʒu
Return  :	̃^uXgbv܂ł̌
Note    :	
-------------------------------------------------------------------------------*/
int GetTabWidth(int tabWidth, int col)
{
	int		tabs;

	tabs = (((col + tabWidth) / tabWidth) * tabWidth) - col;
	return(tabs);
}


/*-------------------------------------------------------------------------------
Name    :	RemoveLineTopTbl
Desc    :	s擪ʒuf[^폜
Param   :	tbl		t@CǗf[^
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void RemoveLineTopTbl(FILEMANTBL *tbl)
{
	LINETOPTBL	*pos;
	LINETOPTBL	*next;

	pos = tbl->LineData;
	while(pos != NULL)
	{
		next = pos->Next;
		free(pos);
		pos = next;
	}
	tbl->LineData = NULL;
	tbl->TextLines = 0;
	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetLineTop
Desc    :	sԍŎw肳ꂽs̐擪̃̕AhX߂
Param   :	tbl		t@CǗf[^
			num		sԍ
Return  :	ʒu
Note    :	
-------------------------------------------------------------------------------*/
LPTSTR GetLineTop(FILEMANTBL *tbl, int num)
{
	LINETOPTBL	*cur;
	int			index;
	LPTSTR		top;

	top = NULL;
	if(ConvLineToTableAndIndex(tbl, num, &cur, &index) == SUCCESS)
	{
		top = cur->LineTop[index];
	}
	return(top);
}


/*-------------------------------------------------------------------------------
Name    :	GetLineLen
Desc    :	sԍŎw肳ꂽs̕Ԃ
Param   :	tbl		t@CǗf[^
			num		sԍ
Return  :	
Note    :	
-------------------------------------------------------------------------------*/
int GetLineLen(FILEMANTBL *tbl, int num)
{
	LINETOPTBL	*cur;
	int			index;
	LPTSTR		top;
	int			ret;

	ret = 0;
	if(ConvLineToTableAndIndex(tbl, num, &cur, &index) == SUCCESS)
	{
		top = cur->LineTop[index];
		MoveToNextTableAndIndex(&cur, &index);
		ret = cur->LineTop[index] - top;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetLogicalLineNum
Desc    :	sԍŎw肳ꂽs̘_sԍ߂
Param   :	tbl		t@CǗf[^
			num		sԍ
Return  :	_sԍ (-1=G[)
Note    :	
-------------------------------------------------------------------------------*/
int GetLogicalLineNum(FILEMANTBL *tbl, int num)
{
	LINETOPTBL	*cur;
	int			index;
	int			ret;

	ret = -1;
	if(ConvLineToTableAndIndex(tbl, num, &cur, &index) == SUCCESS)
	{
		ret = cur->LineNum[index];
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetLineNumFromLogicalLineNum
Desc    :	_sԍsԍ߂
Param   :	tbl		t@CǗf[^
			num		_sԍ
Return  :	sԍ (-1=G[)
Note    :	
-------------------------------------------------------------------------------*/
int GetLineNumFromLogicalLineNum(FILEMANTBL *tbl, int num)
{
	LINETOPTBL	*pos;
	LINETOPTBL	*prev;
	int			tmp;
	int			ret;
	int			i;

	ret = 0;
	tmp = 0;
	pos = tbl->LineData;
	prev = pos;
	while(pos != NULL)
	{
		if(pos->LineNum[0] > num)
		{
			break;
		}
		prev = pos;
		ret += tmp;
		tmp = pos->Lines;
		pos = pos->Next;
	}

	tmp = -1;
	if(prev != NULL)
	{
		for(i = 0; i < prev->Lines; i++)
		{
			if(num == prev->LineNum[i])
			{
				tmp = ret;
				break;
			}
			ret++;
		}
	}
	return(tmp);
}


/*-------------------------------------------------------------------------------
Name    :	GetLineTopFromAdrs
Desc    :	Cӂ̕ʒu炻̂̕s̐擪̃̕AhX߂
Param   :	tbl		t@CǗf[^
			text	ʒu
Return  :	s̕ʒu
Note    :	
-------------------------------------------------------------------------------*/
static LPTSTR GetLineTopFromAdrs(FILEMANTBL *tbl, LPTSTR text)
{
	LINETOPTBL	*pos;
	LINETOPTBL	*prev;
	LPTSTR		ret;
	int			i;

	ret = NULL;
	pos = tbl->LineData;
	prev = pos;
	while(pos != NULL)
	{
		if(text < pos->LineTop[0])
		{
			break;
		}
		prev = pos;
		pos = pos->Next;
	}

	if(prev != NULL)
	{
		ret = prev->LineTop[0];
		for(i = 1; i < prev->Lines; i++)
		{
			if(text < prev->LineTop[i])
			{
				break;
			}
			ret = prev->LineTop[i];
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetLineNumFromAdrs
Desc    :	Cӂ̕ʒu炻̂̕s̍sԍ߂
Param   :	tbl		t@CǗf[^
			text	ʒu
Return  :	sԍ
Note    :	
-------------------------------------------------------------------------------*/
static int GetLineNumFromAdrs(FILEMANTBL *tbl, LPTSTR text)
{
	LINETOPTBL	*pos;
	LINETOPTBL	*prev;
	int			tmp;
	int			ret;
	int			i;

	ret = 0;
	tmp = 0;
	pos = tbl->LineData;
	prev = pos;
	while(pos != NULL)
	{
		if(text < pos->LineTop[0])
		{
			break;
		}
		prev = pos;
		ret += tmp;
		tmp = pos->Lines;
		pos = pos->Next;
	}

	if(prev != NULL)
	{
		for(i = 1; i < prev->Lines; i++)
		{
			if(text < prev->LineTop[i])
			{
				break;
			}
			ret++;
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	ConvLineToTableAndIndex
Desc    :	sԍs擪ʒuf[^e[uƃe[ũCfbNX߂
Param   :	tbl		t@CǗf[^
			num		sԍ
			cur		[out] s擪ʒuf[^e[u
			index	[out] CfbNX
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
static int ConvLineToTableAndIndex(FILEMANTBL *tbl, int num, LINETOPTBL **cur, int *index)
{
	int			sts;
	LINETOPTBL	*pos;

	sts = FAIL;
	pos = tbl->LineData;
	while(pos != NULL)
	{
		if(num < pos->Lines)
		{
			*cur = pos;
			*index = num;
			sts = SUCCESS;
			break;
		}
		else
		{
			num -= pos->Lines;
			pos = pos->Next;
		}
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	MoveToNextTableAndIndex
Desc    :	̍s̃e[uɈړ
Param   :	cur		[out] s擪ʒuf[^e[uԂ[N
			index	[out] CfbNXԂ[N
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void MoveToNextTableAndIndex(LINETOPTBL **cur, int *index)
{
	*index += 1;
	if(*index >= (*cur)->Lines)
	{
		if((*cur)->Next != NULL)
		{
			*cur = (*cur)->Next;
			*index = 0;
		}
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	AskWordTopAndBtm
Desc    :	Cӂ̕ʒu̒P̐擪ƖԂ
Param   :	tbl		t@CǗe[u
			text	ʒu
			top		[out] P̐擪
			btm		[out] P̖
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int AskWordTopAndBtm(FILEMANTBL *tbl, LPTSTR text, LPTSTR *top, LPTSTR *btm)
{
	int		find;
	LPTSTR	lineTop;
	LPTSTR	lineBtm;
	LPTSTR	tmp;
	int		check;

	AskPhysLineTopAndBtm(tbl, text, &lineTop, &lineBtm);

	find = AskCharacterType(text);

	tmp = lineTop;
	while(lineTop < text)
	{
		check = AskCharacterType(lineTop);
		if((check == CHAR_ZEN_CHOU) &&
		   ((find == CHAR_ZEN_HIRA) || (find == CHAR_ZEN_KATA)))
		{
			check = find;
		}
		lineTop++;
		if(find != check)
		{
			tmp = lineTop;
		}
	}
	*top = tmp;

	tmp = lineTop;
	*btm = lineBtm;
	while(lineTop < lineBtm)
	{
		check = AskCharacterType(lineTop);
		if((check == CHAR_ZEN_CHOU) &&
		   ((find == CHAR_ZEN_HIRA) || (find == CHAR_ZEN_KATA)))
		{
			check = find;
		}
		if(find != check)
		{
			*btm = lineTop;
			break;
		}
		lineTop++;
	}
	return(SUCCESS);
}


/*-------------------------------------------------------------------------------
Name    :	AskCharacterType
Desc    :	̎ނԂ
Param   :	text		ʒu
Return  :	̎ (CHAR_xxx)
Note    :	
-------------------------------------------------------------------------------*/
static int AskCharacterType(LPTSTR text)
{
	int		ret;
	int		ch;

	ch = *text;
	if((ch == _T(' ')) || (ch == _T('@')) || (ch == _T('\t')))
	{
		ret = CHAR_SPACE;
	}
	else if(ch < _T(' '))
	{
		ret = CHAR_CTRL;
	}
	else if(((ch >= 0x0030) && (ch <= 0x0039)) ||	/* 0 ... 9 */
			((ch >= 0x0041) && (ch <= 0x005a)) ||	/* A ... Z */
			((ch >= 0x0061) && (ch <= 0x007a)))		/* a ... z */
	{
		ret = CHAR_HAN_ALPHA;
	}
	else if((ch >= 0xFF66) && (ch <= 0xFF9F))
	{
		ret = CHAR_HAN_KANA;
	}
	else if((ch >= 0x3041) && (ch <= 0x3093))
	{
		ret = CHAR_ZEN_HIRA;
	}
	else if((ch >= 0x30A1) && (ch <= 0x30F6))
	{
		ret = CHAR_ZEN_KATA;
	}
	else if(ch == 0x30FC)
	{
		ret = CHAR_ZEN_CHOU;
	}
	else if(((ch >= 0xFF10) && (ch <= 0xFF19)) ||	/* O ... X */
			((ch >= 0xFF21) && (ch <= 0xFF3A)) ||	/* ` ... y */
			((ch >= 0xFF41) && (ch <= 0xFF5A)))		/*  ...  */
	{
		ret = CHAR_ZEN_ALPHA;
	}
	else
	{
		ret = CHAR_OTHER;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	AskPhysLineTopAndBtm
Desc    :	Cӂ̕ʒu̘_s̐擪ƖԂ
Param   :	tbl		t@CǗe[u
			text	ʒu
			top		P̐擪
			btm		P̖
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int AskPhysLineTopAndBtm(FILEMANTBL *tbl, LPTSTR text, LPTSTR *top, LPTSTR *btm)
{
	LPTSTR	tmp;

	tmp = text;
	while((tmp >= tbl->TextData) && (*tmp != _T('\r')) && (*tmp != _T('\n')))
	{
		tmp--;
	}
	tmp++;
	*top = tmp;

	while((tmp < tbl->TextData + tbl->TextSize) && (*tmp != _T('\r')) && (*tmp != _T('\n')))
	{
		tmp++;
	}
	*btm = tmp;

	return(SUCCESS);
}


/*-------------------------------------------------------------------------------
Name    :	SearchText
Desc    :	eLXgŜČʃe[u쐬
Param   :	tbl			t@CǗf[^
			num			݂̍sԍ
			key			L[
			caps		啶Aʂ邩ǂ (YES/NO)
			regexp		K\ (YES/NO)
			scanDist	 (DIST_xxx)
Return  :	݈ʒuȍ~^ȑOōŏɌs̍sԍ
Note    :	
-------------------------------------------------------------------------------*/
int SearchText(FILEMANTBL *tbl, int num, LPTSTR key, int caps, int regexp, int scanDist)
{
	LPTSTR		text;
	LPTSTR		btm;
	_TCHAR		first;
	int			len;
	FOUNDTBL	*prev;
	FOUNDTBL	*Set;
	int			sts;
	LPTSTR		pos;
	int			mLen;

	regex_t* reg;
	OnigErrorInfo einfo;
	OnigRegion *region;
	int r;

	sts = FAIL;
	CancelSearchText(tbl);

	if(_tcslen(key) > 0)
	{
		if(regexp == YES)
		{
#ifdef HAVE_ONIGURUMA
			r = onig_new(&reg, (OnigUChar*)key, (OnigUChar*)(key + _tcslen(key)), ONIG_OPTION_DEFAULT, ONIG_ENCODING_UTF16_LE, ONIG_SYNTAX_DEFAULT, &einfo);
			if(r < ONIG_MISMATCH)
			{
				char s[ONIG_MAX_ERROR_MESSAGE_LEN];
				_TCHAR s1[ONIG_MAX_ERROR_MESSAGE_LEN];
				onig_error_code_to_str((UChar* )s, r);
				MultiByteToWideChar(CP_OEMCP, 0, s, strlen(s)+1, s1, ONIG_MAX_ERROR_MESSAGE_LEN);
				MessageBox(GetMainHwnd(), s1, _T("ttPage"), MB_OK);
				return(-1);
			}
			region = onig_region_new();
#endif
		}

		Set = NULL;
		len = _tcslen(key);
		text = tbl->TextData;
		if(regexp == NO)
		{
			btm = text + tbl->TextSize - (len - 1);
			first = _totlower(*key);
		}
		else
		{
			btm = text + tbl->TextSize;
		}

		while(text < btm)
		{
			pos = NULL;
			if(regexp == NO)
			{
				if((first == _totlower(*text)) &&
				   (((caps == YES) && (_tcsncmp(text, key, _tcslen(key)) == 0)) ||
					((caps == NO) && (_tcsnicmp(text, key, _tcslen(key)) == 0))))
				{
					pos = text;
					mLen = len;
				}
			}
			else
			{
#ifdef HAVE_ONIGURUMA
				r = onig_search(reg, (OnigUChar*)text, (OnigUChar*)btm, (OnigUChar*)text, (OnigUChar*)btm, region, ONIG_OPTION_NONE);
#else
				r = 0;
#endif
				if(r >= 0)
				{
					pos = (LPTSTR)(((char*)text) + region->beg[0]);
					mLen = (region->end[0] - region->beg[0]) / sizeof(_TCHAR);
					if(mLen < 1)
					{
						text = pos + 1;
						continue;
					}
				}
			}

			if(pos != NULL)
			{
				text = pos;

				tbl->FindStrLen = len;
				if(Set == NULL)
				{
					if((Set = Malloc(sizeof(FOUNDTBL))) != NULL)
					{
						Set->StrNum = 1;
						Set->Find[0].Pos = text;
						Set->Find[0].Len = mLen;
						Set->Next = NULL;
						tbl->FoundTbl = Set;
					}
				}
				else if(Set->StrNum == (FOUNDDATAMAX-1))
				{
					prev = Set;
					if((Set = Malloc(sizeof(FOUNDTBL))) != NULL)
					{
						Set->StrNum = 1;
						Set->Find[0].Pos = text;
						Set->Find[0].Len = mLen;
						Set->Next = NULL;
						prev->Next = Set;
					}
				}
				else
				{
					Set->Find[Set->StrNum].Pos = text;
					Set->Find[Set->StrNum].Len = mLen;
					Set->StrNum += 1;
				}
				sts = SUCCESS;

				text += mLen;
			}
			else
			{
				if(regexp == NO)
				{
					text++;
				}
				else
				{
					break;
				}
			}
		}
	}

	if(sts == SUCCESS)
	{
		if(scanDist == DIST_FORWARD)
		{
			sts = SearchNextFoundLine(tbl, num);
		}
		else
		{
			sts = SearchPrevFoundLine(tbl, num);
		}
	}
	else
	{
		sts = -1;
	}

	if(regexp == YES)
	{
#ifdef HAVE_ONIGURUMA
		onig_region_free(region, 1);
		onig_free(reg);
		onig_end();
#endif
	}

	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	CancelSearchText
Desc    :	ʃe[u폜
Param   :	tbl		t@CǗf[^
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void CancelSearchText(FILEMANTBL *tbl)
{
	FOUNDTBL	*pos;
	FOUNDTBL	*next;

	pos = tbl->FoundTbl;
	while(pos != NULL)
	{
		next = pos->Next;
		free(pos);
		pos = next;
	}
	tbl->FoundTbl = NULL;
	tbl->FindStrLen = 0;
	_tcscpy(tbl->FindStr, _T(""));
	return;
}


/*-------------------------------------------------------------------------------
Name    :	SearchNextFoundLine
Desc    :	Ō̍sԍԂ
Param   :	tbl		t@CǗf[^
			num		݂̍sԍ
Return  :	sԍ
Note    :	
-------------------------------------------------------------------------------*/
int SearchNextFoundLine(FILEMANTBL *tbl, int num)
{
	int			ret;
	LINETOPTBL	*cur;
	int			index;
	LPTSTR		pos;
	int			mLen;

	ret = -1;
	if(ConvLineToTableAndIndex(tbl, num, &cur, &index) == SUCCESS)
	{
		MoveToNextTableAndIndex(&cur, &index);
		pos = cur->LineTop[index];

		if((pos = GetNextFoundPos(tbl, pos, &mLen)) != NULL)
		{
			ret = GetLineNumFromAdrs(tbl, pos);
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	SearchPrevFoundLine
Desc    :	ŌO̍sԍԂ
Param   :	tbl		t@CǗf[^
			num		݂̍sԍ
Return  :	sԍ
Note    :	
-------------------------------------------------------------------------------*/
int SearchPrevFoundLine(FILEMANTBL *tbl, int num)
{
	int			ret;
	LINETOPTBL	*cur;
	int			index;
	LPTSTR		pos;
	int			mLen;

	ret = -1;
	if(ConvLineToTableAndIndex(tbl, num, &cur, &index) == SUCCESS)
	{
		pos = cur->LineTop[index];

		if((pos = GetPrevFoundPos(tbl, pos, &mLen)) != NULL)
		{
			ret = GetLineNumFromAdrs(tbl, pos);
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	AskSearched
Desc    :	sĂ邩ǂԂ
Param   :	tbl		t@CǗf[^
Return  :	sĂ邩ǂ (YES/NO)
Note    :	
-------------------------------------------------------------------------------*/
int AskSearched(FILEMANTBL *tbl)
{
	int		sts;

	sts = NO;
	if(tbl->FindStrLen > 0)
	{
		sts = YES;
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	AskCurPosFound
Desc    :	w̕ʒu͈͂ǂԂ
Param   :	tbl		t@CǗf[^
			text	ʒu
Return  :	wʒu܂߈ȍ~Ō
			(0=Ōł͂Ȃ)
Note    :	
-------------------------------------------------------------------------------*/
int AskCurPosFound(FILEMANTBL *tbl, LPTSTR text)
{
	FOUNDTBL	*pos;
	int			ret;
	int			i;

	ret = 0;
	if(tbl->FindStrLen > 0)
	{
		pos = tbl->FoundTbl;
		while(pos != NULL)
		{
			if(text > pos->Find[pos->StrNum-1].Pos)
			{
				if(text <= (pos->Find[pos->StrNum-1].Pos + pos->Find[pos->StrNum-1].Len))
				{
					ret = pos->Find[pos->StrNum-1].Len - (text - pos->Find[pos->StrNum-1].Pos);
					break;
				}
				else
				{
					pos = pos->Next;
				}
			}
			else
			{
				break;
			}
		}

		if((ret == 0) && (pos != NULL))
		{
			for(i = 0; i < pos->StrNum; i++)
			{
				if((text >= pos->Find[i].Pos) &&
				   (text < (pos->Find[i].Pos + pos->Find[i].Len)))
				{
					ret = pos->Find[i].Len - (text - pos->Find[i].Pos);
					break;
				}
			}
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetNextFoundPos
Desc    :	݂̕ʒuȍ~̍ŏ͈̌͂Ԃ
Param   :	tbl		t@CǗf[^
			text	ʒu
			mLen	͈͂̒
Return  :	͈(NULL=Ȃ)
Note    :	
-------------------------------------------------------------------------------*/
LPTSTR GetNextFoundPos(FILEMANTBL *tbl, LPTSTR text, int *mLen)
{
	FOUNDTBL	*pos;
	LPTSTR		ret;
	int			i;

	ret = NULL;
	if(tbl->FindStrLen > 0)
	{
		pos = tbl->FoundTbl;
		while(pos != NULL)
		{
			if(text <= pos->Find[pos->StrNum-1].Pos)
			{
				break;
			}
			pos = pos->Next;
		}

		if(pos != NULL)
		{
			for(i = 0; i < pos->StrNum; i++)
			{
				if(text <= pos->Find[i].Pos)
				{
					ret = pos->Find[i].Pos;
					*mLen = pos->Find[i].Len;
					break;
				}
			}
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetPrevFoundPos
Desc    :	݂̕ʒuȑO̍Ō͈̌͂Ԃ
Param   :	tbl		t@CǗf[^
			text	ʒu
			mLen	͈͂̒
Return  :	͈(NULL=Ȃ)
Note    :	
-------------------------------------------------------------------------------*/
LPTSTR GetPrevFoundPos(FILEMANTBL *tbl, LPTSTR text, int *mLen)
{
	FOUNDTBL	*pos;
	FOUNDTBL	*prev;
	LPTSTR		ret;
	int			i;

	ret = NULL;
	if(tbl->FindStrLen > 0)
	{
		pos = tbl->FoundTbl;
		prev = NULL;
		while(pos != NULL)
		{
			if(text <= pos->Find[pos->StrNum-1].Pos)
			{
				break;
			}
			prev = pos;
			pos = pos->Next;
		}

		if(pos != NULL)
		{
			for(i = pos->StrNum-1; i >= 0; i--)
			{
				if(text > pos->Find[i].Pos)
				{
					ret = pos->Find[i].Pos;
					*mLen = pos->Find[i].Len;
					break;
				}
			}
		}

		if((ret == NULL) && (prev != NULL))
		{
			ret = prev->Find[prev->StrNum-1].Pos;
			*mLen = prev->Find[prev->StrNum-1].Len;
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	MakeAttributeTable
Desc    :	eLXgŜ̃Agr[ge[u쐬
Param   :	tbl		t@CǗf[^
Return  :	none
Note    :	̃p^[`FbN i^H  Ctrl-H \j
				_^HA  --- AɃA_[C
				A^HA  --- A̋
-------------------------------------------------------------------------------*/
void MakeAttributeTable(FILEMANTBL *tbl)
{
	LPTSTR	get;
	LPTSTR	put;
	LPTSTR	btm;
	LPTSTR	prev;
	LPTSTR	chAttrTop;
	LPTSTR	chAttrBtm;
	int		chkAttr;
	ATTRTBL	*prevTbl;
	ATTRTBL	*setTbl;

	RemoveAttributeTable(tbl);

	/*===== A Ctrl-H Pɂ =====*/

	get = tbl->TextData;
	btm = get + tbl->TextSize;
	chkAttr = NO;
	while((get = wmemchr(get, 0x0008, btm - get)) != NULL)
	{
		get++;
		prev = get;
		while((get < btm) && (*get == 0x0008))
		{
			get++;
		}
		wmemmove(prev, get, btm - get);
		btm -= (get - prev);
		chkAttr = YES;
	}

	/*===== Agr[g쐬 =====*/

	if(chkAttr == YES)
	{
		setTbl = NULL;

		get = tbl->TextData;
		put = get;
		prev = NULL;
		while(get < btm)
		{
			if((*get == 0x0008) && (prev != NULL))	/* Ctrl-H */
			{
				chAttrTop = prev;
				chAttrBtm = NULL;

				/* A_[C̃`FbN */
				chkAttr = ATTR_UNDER;

				while(((btm-get) >= 2) &&
					  (*get == 0x0008) &&
					  (((*prev == _T('_')) || (*(get+1) == _T('_')))))
				{
					get++;
					if(*prev == _T('_'))
					{
						put--;
						*put++ = *get++;
					}
					else
					{
						get++;
					}

					chAttrBtm = put;

					if(get >= btm)
					{
						break;
					}

					if(*get != 0x08)
					{
						prev = put;
						*put++ = *get++;
					}
				}

				if(chAttrBtm == NULL)
				{
					/* ̃`FbN */
					chkAttr = ATTR_BOLD;

					while(((btm-get) >= 2) &&
						  (*get == 0x08) &&
						  (*prev == *(get+1)))
					{
						get += 2;

						chAttrBtm = put;

						if(get >= btm)
						{
							break;
						}

						if(*get != 0x08)
						{
							prev = put;
							*put++ = *get++;
						}
					}
				}

				if(chAttrBtm != NULL)
				{
					/* A_[C^e[uɃZbg */
					if(setTbl == NULL)
					{
						if((setTbl = Malloc(sizeof(ATTRTBL))) != NULL)
						{
							setTbl->Attr[0].AttrPos = chAttrTop;
							setTbl->Attr[0].AttrLen = chAttrBtm - chAttrTop;
							setTbl->Attr[0].AttrData = chkAttr;
							setTbl->AttrNum = 1;
							setTbl->Next = NULL;
							tbl->AttrData = setTbl;
						}
					}
					else if(setTbl->AttrNum == (ATTRDATAMAX-1))
					{
						prevTbl = setTbl;
						if((setTbl = Malloc(sizeof(ATTRTBL))) != NULL)
						{
							setTbl->Attr[0].AttrPos = chAttrTop;
							setTbl->Attr[0].AttrLen = chAttrBtm - chAttrTop;
							setTbl->Attr[0].AttrData = chkAttr;
							setTbl->AttrNum = 1;
							setTbl->Next = NULL;
							prevTbl->Next = setTbl;
						}
					}
					else
					{
						setTbl->Attr[setTbl->AttrNum].AttrPos = chAttrTop;
						setTbl->Attr[setTbl->AttrNum].AttrLen = chAttrBtm - chAttrTop;
						setTbl->Attr[setTbl->AttrNum].AttrData = chkAttr;
						setTbl->AttrNum += 1;
					}
				}
				else
				{
					/* obNXy[XőO̕폜 */
					put = prev;
					get++;
					*put++ = *get++;
				}
			}
			else
			{
				prev = put;
				*put++ = *get++;
			}
		}

		tbl->TextSize = put - tbl->TextData;
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	RemoveAttributeTable
Desc    :	Agr[ge[u폜
Param   :	tbl		t@CǗf[^
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void RemoveAttributeTable(FILEMANTBL *tbl)
{
	ATTRTBL	*pos;
	ATTRTBL	*next;

	pos = tbl->AttrData;
	while(pos != NULL)
	{
		next = pos->Next;
		free(pos);
		pos = next;
	}
	tbl->AttrData = NULL;
	return;
}


/*-------------------------------------------------------------------------------
Name    :	AskCurPosAttr
Desc    :	w̕ʒuɃAgr[gĂ邩ǂԂ
Param   :	tbl		t@CǗf[^
			text	ʒu
			len		ʒuȍ~ɃAgr[gĂ邩Ԃ[N
			attr	Agr[gԂ[N
Return  :	ʒuȍ~ɃAgr[gĂ邩
			(0=Agr[g͂ĂȂ)
Note    :	
-------------------------------------------------------------------------------*/
int AskCurPosAttr(FILEMANTBL *tbl, LPTSTR text, int *len, int *attr)
{
	ATTRTBL	*pos;
	int		ret;
	int		i;

	ret = 0;
	pos = tbl->AttrData;
	while(pos != NULL)
	{
		if(text > pos->Attr[pos->AttrNum-1].AttrPos)
		{
			if(text <= (pos->Attr[pos->AttrNum-1].AttrPos + pos->Attr[pos->AttrNum-1].AttrLen))
			{
				ret = pos->Attr[pos->AttrNum-1].AttrLen - (text - pos->Attr[pos->AttrNum-1].AttrPos);
				*len = ret;
				*attr = pos->Attr[pos->AttrNum-1].AttrData;
				break;
			}
			else
			{
				pos = pos->Next;
			}
		}
		else
		{
			break;
		}
	}

	if((ret == 0) && (pos != NULL))
	{
		for(i = 0; i < pos->AttrNum; i++)
		{
			if((text >= pos->Attr[i].AttrPos) &&
			   (text < (pos->Attr[i].AttrPos + pos->Attr[i].AttrLen)))
			{
				ret = pos->Attr[i].AttrLen - (text - pos->Attr[i].AttrPos);
				*len = ret;
				*attr = pos->Attr[i].AttrData;
				break;
			}
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetNextAttrPos
Desc    :	݂̕ʒuȍ~ōŏɃAgr[gĂ͈͂Ԃ
Param   :	tbl		t@CǗf[^
			text	ʒu
			len		Agr[g̒Ԃ[N
			attr	Agr[gԂ[N
Return  :	Agr[gJnʒu(NULL=Ȃ)
Note    :	
-------------------------------------------------------------------------------*/
LPTSTR GetNextAttrPos(FILEMANTBL *tbl, LPTSTR text, int *len, int *attr)
{
	ATTRTBL	*pos;
	LPTSTR	ret;
	int		i;

	ret = NULL;
	*len = 0;
	*attr = 0;
	pos = tbl->AttrData;
	while(pos != NULL)
	{
		if(text <= pos->Attr[pos->AttrNum-1].AttrPos)
		{
			break;
		}
		pos = pos->Next;
	}

	if(pos != NULL)
	{
		for(i = 0; i < pos->AttrNum; i++)
		{
			if(text <= pos->Attr[i].AttrPos)
			{
				ret = pos->Attr[i].AttrPos;
				*len = pos->Attr[i].AttrLen;
				*attr = pos->Attr[i].AttrData;
				break;
			}
		}
	}
	return(ret);
}


