/*===========================================================================
/
/                                   ttPage
/                               CvO
/
/============================================================================
/ Copyright (C) 1998-2018 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without
/ modification, are permitted provided that the following conditions
/ are met:
/
/  1. Redistributions of source code must retain the above copyright
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright
/     notice, this list of conditions and the following disclaimer in the
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

/* Kazuya NOGUCHI ɂC܂݂܂B */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdarg.h>
#include <zmouse.h>
#include <shlobj.h>
#include <tchar.h>
#include <htmlhelp.h>
#include <winnls32.h>

#include "common.h"
#include "resource.h"

/*===== vg^Cv =====*/

static void InitGlobalSet(void);
static int InitApp(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpszCmdLine, int cmdShow);
static void DeleteAllObject(void);
static LRESULT CALLBACK ttPageWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static void ExitProc(HWND hWnd);
static void AskWindowSize(void);
static void ResizeWindowProc(void);
static int AnalyzeComLine(LPTSTR str, LPTSTR filename, int *option, int *topLine);
static LPTSTR GetToken(LPTSTR str, LPTSTR buf, int flag);
static void SaveFileAs(FILEMANTBL *tbl);
static BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);


/*===== [Jȃ[N ======*/

static const _TCHAR ttPageClassStr[] = _T("ttPageClass");
static HINSTANCE hInstttPage;

static HWND hWndttPage = NULL;

static int SaveExit = YES;

#if 0
static int WinNT;
#endif

static _TCHAR HelpPath[MAX_PATH+1];
static _TCHAR IniPath[MY_MAX_PATH+1];

static DWORD dwCookie;

static UINT puiMsh_MsgMouseWheel;
static UINT puiMsh_MsgScrollLines;


/*===== O[oȃ[N ======*/

HACCEL AcceletorHandle = NULL;
int CurExtSet = 0;
int LineNum;
HFONT hFontttPage = NULL;
HWND hWndHelp = NULL;

GLOBALSET   GlobalSet;          /* ݒl */

static const int DefaultExtSetNum = 1;
static const EXTSET DefaultExtSetTbl[] = {
    {
        MSGJPN_6,
        _T(""),
        8,
        80,
        5,
        YES,
        NO,
        NO,
        NO,
        NO,
        LINENUM_WP,
        YES,
        { -15, 0, FALSE, FALSE, FW_NORMAL, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_STRING_PRECIS, CLIP_STROKE_PRECIS, DRAFT_QUALITY, FIXED_PITCH, _T("FixedSys") },
        RGB(0,0,0),
        RGB(255,0,0),
        RGB(255,255,255),
        RGB(128,255,255),
        RGB(128,128,128),
        RGB(128,128,128),
        RGB(128,128,128),
        RGB(128,128,128),
        RGB(128,128,128),
        TOOL_TYPE_ASSOC,
        NO,
        NO,
        _T("notepad $F"),
        _T(""),
        _T(""),
        _T(""),
        _T(""),
        _T(""),
        _T(""),
        _T("")
    }
};


/* _vsnprintfg߂̊֐B
   R͕sAvO_vsnprintfgȂƁAonig_s.lib_vsnprintf
   ȂƂNG[ƂȂĂ܂B
   ̑΍pB  2017/7/24 */
void testFunc(char *buf, int n, char *format, ...)
{
    va_list arg;
    va_start(arg, format);
    _vsnprintf(buf, 10, format, arg);
    va_end(arg);
}


/*-------------------------------------------------------------------------------
Name    :   _tWinMain
Desc    :   C[`
Param   :   hInstance       ̃AvP[V̂̃CX^X̃nh
            hPrevInstance   ̃AvP[V̒ÕCX^X̃nh
            lpszCmdLine     AvP[VNƂ̃R}hCO|C^
            cmdShow         ŏɕ\EChĚ`
Return  :   vOIR[h
Note    :
-------------------------------------------------------------------------------*/
int PASCAL _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpszCmdLine, int cmdShow)
{
    MSG     msg;
    int     ret;
    LPTSTR  cmdLine;

    InitCommonControls();
    InitGlobalSet();

    ret = FALSE;
    hWndttPage = NULL;
    hInstttPage = hInstance;
    cmdLine = GetCommandLine();
    if(InitApp(hInstance, hPrevInstance, cmdLine, cmdShow) == SUCCESS)
    {
        while(GetMessage(&msg, NULL, 0, 0))
        {
            if(!HtmlHelp(NULL, NULL, HH_PRETRANSLATEMESSAGE, (DWORD)&msg))
            {

                if(((hWndHelp != NULL) && (GetAncestor(msg.hwnd, GA_ROOT) == hWndHelp)) ||
                   (TranslateAccelerator(hWndttPage, AcceletorHandle, &msg) == 0))
                {
                    TranslateMessage(&msg);
                    DispatchMessage(&msg);
                }
            }
        }
        ret = msg.wParam;
    }
    UnregisterClass(ttPageClassStr, hInstttPage);
    return(ret);
}



/*-------------------------------------------------------------------------------
Name    :   InitGlobalSet
Desc    :   O[oȐݒl
Param   :   none
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
static void InitGlobalSet(void)
{
    GlobalSet.ExtSetTbl = NULL;
    GlobalSet.ExtSetNum = 0;
    GlobalSet.ExtSetMax = EXT_NUM_STEP;

    GlobalSet.WinPosX = CW_USEDEFAULT;
    GlobalSet.WinPosY = 0;
    GlobalSet.WinWidth = CW_USEDEFAULT;
    GlobalSet.WinHeight = 0;
    GlobalSet.Maximize = NO;

    GlobalSet.SaveWinSize = YES;
    GlobalSet.SaveWinPos = NO;
    GlobalSet.ToolBar = YES;
    GlobalSet.StatusBar = YES;
    GlobalSet.RegType = REGTYPE_REG;
    _tcscpy(GlobalSet.QuoteStr, _T(">"));

    GlobalSet.ErrBell = YES;
    GlobalSet.FileHist = 5;

    _tcscpy(GlobalSet.FindData.Str, _T(""));
    GlobalSet.FindData.CapsFlg = NO;
    GlobalSet.FindData.Regexp = NO;
    _tcscpy(GlobalSet.FindHist, _T(""));

    GlobalSet.DispCaret = NO;

    GlobalSet.SmoothLine = NO;
    GlobalSet.SmoothPage = NO;
    GlobalSet.SmoothRate = 15;

    GlobalSet.AcceleratorTable = NULL;
    GlobalSet.AcceleratorDataNum = 0;
    GlobalSet.AcceleratorDataMax = 0;

    return;
}


/*-------------------------------------------------------------------------------
Name    :   InitApp
Desc    :   AvP[V̏
Param   :   hInstance       ̃AvP[V̂̃CX^X̃nh
            hPrevInstance   ̃AvP[V̒ÕCX^X̃nh
            lpszCmdLine     AvP[VNƂ̃R}hCO|C^
            cmdShow         ŏɕ\EChĚ`B
Return  :   Xe[^X (SUCCESS/FAIL)
Note    :
-------------------------------------------------------------------------------*/
static int InitApp(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpszCmdLine, int cmdShow)
{
    int         sts;
    WNDCLASSEX  wClass;
    _TCHAR      filename[MAX_PATH+1];
    int         option;
    LPTSTR      histry;
    int         topLine;
    int         encoding;

    sts = FAIL;

#if 0
    WinNT = YES;
    if(GetVersion() & 0x80000000)
    {
        WinNT = NO;
    }
#endif

    HtmlHelp(NULL, NULL, HH_INITIALIZE, (DWORD)&dwCookie);

    SaveUpdateBellInfo();

    GetModuleFileName(NULL, HelpPath, MAX_PATH);
    _tcscpy(GetFileName(HelpPath), _T("ttpage.chm"));

    GetModuleFileName(NULL, IniPath, MY_MAX_PATH);
    _tcscpy(GetFileName(IniPath), _T("ttPage.ini"));


    if((histry = Malloc((MAX_PATH+1)*HISTORY_MAX+1)) != NULL)
    {
        if(LoadRegistory(histry) == NO)
        {
            /* ۑꂽݒȂBftHglKpB */
            GlobalSet.ExtSetTbl = Malloc(GlobalSet.ExtSetMax * sizeof(EXTSET));
            memcpy(GlobalSet.ExtSetTbl, DefaultExtSetTbl, DefaultExtSetNum * sizeof(EXTSET));
            GlobalSet.ExtSetNum = DefaultExtSetNum;
            CopyPresetAppKeyTable(UI_WINDOWS);
        }
        if(GlobalSet.SaveWinPos == NO)
        {
            GlobalSet.WinPosX = CW_USEDEFAULT;
            GlobalSet.WinPosY = 0;
        }
        if(GlobalSet.SaveWinSize == NO)
        {
            GlobalSet.WinWidth = CW_USEDEFAULT;
            GlobalSet.WinHeight = 0;
            GlobalSet.Maximize = NO;
        }
        SetViewBackColor(AskCurExtSet()->BackColor);
        LineNum = AskCurExtSet()->LineNumDisp;

//      AllocConsole();

        wClass.cbSize        = sizeof(WNDCLASSEX);
        wClass.style         = 0;
        wClass.lpfnWndProc   = ttPageWndProc;
        wClass.cbClsExtra    = 0;
        wClass.cbWndExtra    = 0;
        wClass.hInstance     = hInstance;
        wClass.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(ttpage));
        wClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wClass.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
        wClass.lpszMenuName  = (LPTSTR)MAKEINTRESOURCE(main_menu);
        wClass.lpszClassName = ttPageClassStr;
        wClass.hIconSm       = NULL;
        RegisterClassEx(&wClass);

#if 0
        if(WinNT == NO)
        {
            puiMsh_MsgMouseWheel = RegisterWindowMessage(MSH_MOUSEWHEEL);
            puiMsh_MsgScrollLines = RegisterWindowMessage(MSH_SCROLL_LINES);
        }
#endif

        hWndttPage = CreateWindow(ttPageClassStr, _T("ttPage"),
                    WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                    GlobalSet.WinPosX, GlobalSet.WinPosY, GlobalSet.WinWidth, GlobalSet.WinHeight,
                    HWND_DESKTOP, 0, hInstance, NULL);
        if(hWndttPage != NULL)
        {
            CoInitialize(NULL);
            SetMenuAndKey();

            if(GlobalSet.ToolBar == YES)
            {
                MakeToolBarWindow(hWndttPage);
            }
            if(GlobalSet.StatusBar == YES)
            {
                MakeStatusWindow(hWndttPage);
            }
            MakeNumWindow(hWndttPage);
            MakeViewWindow(hWndttPage);

            SetAllHistoryToMenu(histry, GlobalSet.FileHist);

            SetFontSize();

            if((cmdShow != SW_MINIMIZE) &&
               (cmdShow != SW_SHOWMINIMIZED) &&
               (cmdShow != SW_SHOWMINNOACTIVE) &&
               (GlobalSet.Maximize == YES))
            {
                cmdShow = SW_MAXIMIZE;
            }
            ShowWindow(hWndttPage, cmdShow);
            WINNLSEnableIME(NULL, FALSE);       /* IME OFF */
            MakeButtonsHide();

            if(AnalyzeComLine(lpszCmdLine, filename, &option, &topLine) == SUCCESS)
            {
                if(_tcslen(filename) != 0)
                {
                    if(option & OPT_SJIS)
                    {
                        encoding = ENCODE_SJIS;
                    }
                    else if(option & OPT_JIS)
                    {
                        encoding = ENCODE_JIS;
                    }
                    else if(option & OPT_EUC)
                    {
                        encoding = ENCODE_EUC;
                    }
                    else if(option & OPT_UTF16)
                    {
                        encoding = ENCODE_UTF16_CHECK;
                    }
                    else if(option & OPT_UTF16BE)
                    {
                        encoding = ENCODE_UTF16_BE_CHECK;
                    }
                    else if(option & OPT_UTF8)
                    {
                        encoding = ENCODE_UTF8_CHECK;
                    }
                    else if(option & OPT_UTF7)
                    {
                        encoding = ENCODE_UTF7_NOBOM;
                    }
                    else
                    {
                        encoding = ENCODE_AUTO;
                    }
                    OpenViewFromFile(filename, topLine, encoding, NO);
                }
                else
                {
                    OpenViewFromStdin(topLine);
                }

                MakeButtonsHide();
                sts = SUCCESS;
            }
        }
        free(histry);
    }

    if(sts == FAIL)
    {
        DeleteAllObject();
    }
    return(sts);
}


/*-------------------------------------------------------------------------------
Name    :   DeleteAllObject
Desc    :   SẴIuWFNg폜
Param   :   none
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
static void DeleteAllObject(void)
{
    if(hWndttPage != NULL)
    {
        DestroyWindow(hWndttPage);
    }
    DeleteNumWindow();
    DeleteViewWindow();
    UnregistAppKeyTable();
    return;
}


/*-------------------------------------------------------------------------------
Name    :   GetProgInst
Desc    :   vÕCX^XԂ
Param   :   none
Return  :   CX^X
Note    :
-------------------------------------------------------------------------------*/
HINSTANCE GetProgInst(void)
{
    return(hInstttPage);
}


/*-------------------------------------------------------------------------------
Name    :   GetMainHwnd
Desc    :   CEChẼEChEnhԂ
Param   :   none
Return  :   EChEnh
Note    :
-------------------------------------------------------------------------------*/
HWND GetMainHwnd(void)
{
    return(hWndttPage);
}


/*-------------------------------------------------------------------------------
Name    :   AskHelpFilePath
Desc    :   wvt@C̃pXԂ
Param   :   none
Return  :   pX
Note    :
-------------------------------------------------------------------------------*/
LPTSTR AskHelpFilePath(void)
{
    return(HelpPath);
}


/*-------------------------------------------------------------------------------
Name    :   AskIniFilePath
Desc    :   INIt@C̃pXԂ
Param   :   none
Return  :   pX
Note    :
-------------------------------------------------------------------------------*/
LPTSTR AskIniFilePath(void)
{
    return(IniPath);
}


/*-------------------------------------------------------------------------------
Name    :   AskIniFilePathAnsi
Desc    :   INIt@C̃pXԂ(ANSI)
Param   :   none
Return  :   pX
Note    :   pXfree邱
-------------------------------------------------------------------------------*/
char *AskIniFilePathAnsi(void)
{
    char    *oemStr;    /* not _TCHAR */
    int     length;

    /* convert filename to OEM character set */
    length = WideCharToMultiByte(CP_OEMCP, 0, IniPath, -1, NULL, 0, NULL, NULL);
    oemStr = (char*)Malloc(length+1);
    memset(oemStr, NUL, length+1);
    WideCharToMultiByte(CP_OEMCP, 0, IniPath, -1, oemStr, length, NULL, NULL);
    return(oemStr);
}


/*-------------------------------------------------------------------------------
Name    :   ttPageWndProc
Desc    :   CEChẼbZ[W
Param   :   hWnd    EChEnh
            message bZ[Wԍ
            wParam  bZ[W WPARAM 
            lParam  bZ[W LPARAM 
Return  :   LRESULT
Note    :
-------------------------------------------------------------------------------*/
static LRESULT CALLBACK ttPageWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    _TCHAR          filename[MAX_PATH+1];
    int             tmpTabWidth;
    int             tmpFoldPos;
    FILEMANTBL      *curFile;
    LPTOOLTIPTEXT   lpttt;
#if 0
    HWND            hdlMsWheel;
#endif
    int             wheelScroll;
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: start
    _TCHAR          buf[MAX_PATH+11];
    LPTSTR          sFname ;
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: end
    int             encode;

    curFile = AskCurFileTbl();

#if 0
    if((WinNT == NO) && (message == puiMsh_MsgMouseWheel))
    {
        message = WM_MOUSEWHEEL95;
    }
#endif

    switch (message)
    {
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: start
        case WM_ACTIVATE :
            if( !curFile )
            {
                break ;
            }
            if(curFile->ReadFrom != READFROM_FILE)
            {
                break ;
            }

            switch(LOWORD(wParam))
            {
                case WA_INACTIVE :
                    sFname = _tcsrchr(curFile->Fname,_T('\\')) ;
                    sFname = sFname ? sFname+1 : curFile->Fname ;
                    break ;
                default :
                    sFname = curFile->Fname ;
                    break ;
            }

            _stprintf( buf, _T("%s - ttPage"), sFname ) ;

            SendMessage(GetMainHwnd(), WM_SETTEXT, 0, (LPARAM)buf);
            break ;
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: end

        case WM_COMMAND :
            switch(LOWORD(wParam))
            {
                case MENU_OPEN :
                    WINNLSEnableIME(NULL, TRUE);    /* IME ON */
                    _tcscpy(filename, _T(""));
                    if(SelectFileToOpenEx(hWnd, filename, MSGJPN_7, MSGJPN_8, _T(""), &encode) == TRUE)
                    {
                        OpenViewFromFile(filename, 0, encode, NO);
                    }
                    WINNLSEnableIME(NULL, FALSE);   /* IME OFF */
                    MakeButtonsHide();
                    break;

                case MENU_SJIS :
                    if(curFile->Encoding != ENCODE_SJIS)
                    {
                        ReopenViewFromFile(ENCODE_SJIS);
                    }
                    break;

                case MENU_JIS :
                    if(curFile->Encoding != ENCODE_JIS)
                    {
                        ReopenViewFromFile(ENCODE_JIS);
                    }
                    break;

                case MENU_EUC :
                    if(curFile->Encoding != ENCODE_EUC)
                    {
                        ReopenViewFromFile(ENCODE_EUC);
                    }
                    break;

                case MENU_UTF16 :
                    if((curFile->Encoding != ENCODE_UTF16_BOM) && (curFile->Encoding != ENCODE_UTF16_NOBOM))
                    {
                        ReopenViewFromFile(ENCODE_UTF16_CHECK);
                    }
                    break;

                case MENU_UTF16_BE :
                    if((curFile->Encoding != ENCODE_UTF16_BOM_BE) && (curFile->Encoding != ENCODE_UTF16_NOBOM_BE))
                    {
                        ReopenViewFromFile(ENCODE_UTF16_BE_CHECK);
                    }
                    break;

                case MENU_UTF8 :
                    if((curFile->Encoding != ENCODE_UTF8_BOM) && (curFile->Encoding != ENCODE_UTF8_NOBOM))
                    {
                        ReopenViewFromFile(ENCODE_UTF8_CHECK);
                    }
                    break;

                case MENU_UTF7 :
                    if(curFile->Encoding != ENCODE_UTF7_NOBOM)
                    {
                        ReopenViewFromFile(ENCODE_UTF7_NOBOM);
                    }
                    break;

                case MENU_HIST_1 :
                case MENU_HIST_2 :
                case MENU_HIST_3 :
                case MENU_HIST_4 :
                case MENU_HIST_5 :
                case MENU_HIST_6 :
                case MENU_HIST_7 :
                case MENU_HIST_8 :
                case MENU_HIST_9 :
                case MENU_HIST_10 :
                case MENU_HIST_11 :
                case MENU_HIST_12 :
                case MENU_HIST_13 :
                case MENU_HIST_14 :
                case MENU_HIST_15 :
                case MENU_HIST_16 :
                case MENU_HIST_17 :
                case MENU_HIST_18 :
                case MENU_HIST_19 :
                case MENU_HIST_20 :
                    if(GetFnameFromHistory(LOWORD(wParam), filename) == SUCCESS)
                    {
                        OpenViewFromFile(filename, 0, ENCODE_AUTO, NO);
                    }
                    MakeButtonsHide();
                    break;

                case MENU_SAVEAS :
                    WINNLSEnableIME(NULL, TRUE);    /* IME ON */
                    SaveFileAs(curFile);
                    WINNLSEnableIME(NULL, FALSE);   /* IME OFF */
                    break;

                case MENU_PASTE :
                    if(DialogBox(hInstttPage, MAKEINTRESOURCE(paste_dlg), hWnd, ExeEscDialogProc) == YES)
                    {
                        OpenViewFromClipBoard(0);
                        MakeButtonsHide();
                    }
                    break;

                case MENU_REDRAW :
                    InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
                    InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
                    if(curFile != NULL)
                    {
                        SetScrollBar();
                    }
                    break;

                case MENU_FILESET :
                    tmpTabWidth = AskCurExtSet()->TabWidth;
                    tmpFoldPos = AskCurExtSet()->FoldPos;
                    WINNLSEnableIME(NULL, TRUE);    /* IME ON */
                    if(DispPatSetDlg(hWnd) == YES)
                    {
                        SetMenuAndKey();
                        SetCurSetWin();
                        if(curFile != NULL)
                        {
                            SetCurExtNum();
                            LineNum = AskCurExtSet()->LineNumDisp;
                            SetViewBackColor(AskCurExtSet()->BackColor);
                            SetFontSize();
                            SetCellSize();
                            /* E[Ő܂ԂResizeViewWindow()MakeLineTopTbl()s */
                            if(AskCurExtSet()->FoldRight == NO)
                            {
                                if((AskCurExtSet()->TabWidth != tmpTabWidth) ||
                                   (AskCurExtSet()->FoldPos != tmpFoldPos))
                                {
                                    MakeLineTopTbl(curFile);
                                    if(curFile->DispTopLine > curFile->TextLines-1)
                                    {
                                        curFile->DispTopLine = curFile->TextLines-1;
                                    }
                                }
                            }
                            CalcLineNumWinWidth();
                            ResizeNumWindow();
                            ResizeViewWindow();
                            SetWindowSize();
                            SetScrollBar();
                            DispCurrentLineNum(STATUS_WIN_TOP_LINE_NUM, curFile->DispTopLine);
                            DispMousePos();
                        }
                        InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
                        InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
                    }
                    WINNLSEnableIME(NULL, FALSE);   /* IME OFF */
                    break;

                case MENU_DISPSET :
                    tmpTabWidth = AskCurExtSet()->TabWidth;
                    tmpFoldPos = AskCurExtSet()->FoldPos;
                    WINNLSEnableIME(NULL, TRUE);    /* IME ON */
                    if(SetOption(hWnd) == YES)
                    {
                        SetMenuAndKey();
                        SetCurSetWin();
                        if(curFile != NULL)
                        {
                            SetCurExtNum();
                            LineNum = AskCurExtSet()->LineNumDisp;
                            SetViewBackColor(AskCurExtSet()->BackColor);
                            SetFontSize();
                            SetCellSize();
                            /* E[Ő܂ԂResizeViewWindow()MakeLineTopTbl()s */
                            if(AskCurExtSet()->FoldRight == NO)
                            {
                                if((AskCurExtSet()->TabWidth != tmpTabWidth) ||
                                   (AskCurExtSet()->FoldPos != tmpFoldPos))
                                {
                                    MakeLineTopTbl(curFile);
                                    if(curFile->DispTopLine > curFile->TextLines-1)
                                    {
                                        curFile->DispTopLine = curFile->TextLines-1;
                                    }
                                }
                            }
                            CalcLineNumWinWidth();
                            ResizeNumWindow();
                            ResizeViewWindow();
                            SetWindowSize();
                            SetScrollBar();
                            DispCurrentLineNum(STATUS_WIN_TOP_LINE_NUM, curFile->DispTopLine);
                            DispMousePos();
                        }
                        InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
                        InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
                    }
                    WINNLSEnableIME(NULL, FALSE);   /* IME OFF */
                    break;

                case MENU_EDITOR :
                    if(curFile != NULL)
                    {
                        ExecEditor(curFile, hWnd, WM_US_EDIT_CLOSE, wParam, lParam);
                    }
                    break;

                case MENU_EXIT :
                    PostMessage(hWnd, WM_CLOSE, 0, 0L);
                    break;

                case MENU_HELP :
                    hWndHelp = HtmlHelp(NULL, AskHelpFilePath(), HH_HELP_CONTEXT, IDH_HELP_TOPIC_0000002);
                    break;

//              case MENU_QA :
//                  HtmlHelp(NULL, AskHelpFilePath(), HH_HELP_CONTEXT, IDH_HELP_TOPIC_0000002);
                    break;

                case MENU_ABOUT :
                    DialogBox(hInstttPage, MAKEINTRESOURCE(about_dlg), hWnd, AboutDialogProc);
                    break;

                case MENU_REGINIT :
                    if(DialogBox(hInstttPage, MAKEINTRESOURCE(reginit_dlg), hWnd, ExeEscDialogProc) == YES)
                    {
                        ClearRegistory();
                        SaveExit = NO;
                        PostMessage(hWnd, WM_CLOSE, 0, 0L);
                    }
                    break;

                case MENU_REGSAVE :
                    AskWindowSize();
                    SaveRegistory();
                    SaveSettingsToFile();
                    break;

                case MENU_REGLOAD :
                    if(LoadSettingsFromFile() == YES)
                    {
                        DialogBoxParam(GetProgInst(), MAKEINTRESOURCE(common_msg_dlg), hWnd, ExeEscMsgDialogProc, (LPARAM)MSGJPN_54);
                        SaveExit = NO;
                        PostMessage(hWnd, WM_CLOSE, 0, 0L);
                    }
                    break;

                case WIN_SETNAME :
                    tmpTabWidth = AskCurExtSet()->TabWidth;
                    tmpFoldPos = AskCurExtSet()->FoldPos;
                    if(HIWORD(wParam) == CBN_SELCHANGE)
                    {
                        if(curFile != NULL)
                        {
                            CurExtSet = SendMessage(GetCurSetWinHwnd(), CB_GETCURSEL, 0, 0);
                            LineNum = AskCurExtSet()->LineNumDisp;
                            SetViewBackColor(AskCurExtSet()->BackColor);
                            SetFontSize();
                            SetCellSize();
                            /* E[Ő܂ԂResizeViewWindow()MakeLineTopTbl()s */
                            if(AskCurExtSet()->FoldRight == NO)
                            {
                                if((AskCurExtSet()->TabWidth != tmpTabWidth) ||
                                   (AskCurExtSet()->FoldPos != tmpFoldPos))
                                {
                                    MakeLineTopTbl(curFile);
                                    if(curFile->DispTopLine > curFile->TextLines-1)
                                    {
                                        curFile->DispTopLine = curFile->TextLines-1;
                                    }
                                }
                            }
                            CalcLineNumWinWidth();
                            ResizeNumWindow();
                            ResizeViewWindow();
                            SetWindowSize();
                            SetScrollBar();
                            DispCurrentLineNum(STATUS_WIN_TOP_LINE_NUM, curFile->DispTopLine);
                            DispMousePos();
                        }
                        InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
                        InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
                    }
                    break;

                case MENU_FIND :
                    WINNLSEnableIME(NULL, TRUE);    /* IME ON */
                    /* break͂Ȃ */
                case MENU_NEXTLINE :
                case MENU_PREVLINE :
                case MENU_NEXT5LINE :
                case MENU_PREV5LINE :
                case MENU_NEXTPAGE :
                case MENU_PREVPAGE :
                case MENU_FILEBTM :
                case MENU_FILETOP :
                case MENU_RIGHT :
                case MENU_LEFT :
                case MENU_RIGHT5 :
                case MENU_LEFT5 :
                case MENU_FINDBACKWD :
                case MENU_FINDNEXT :
                case MENU_FINDPREV :
                case MENU_FINDDISP :
                case MENU_SELALL :
                case MENU_COPY :
                case MENU_APPENDCOPY :
                case MENU_QUOTECOPY :
                case MENU_GOTO :
                    SendMessage(GetViewWinHwnd(), WM_COMMAND, wParam, lParam);
                    WINNLSEnableIME(NULL, FALSE);   /* IME ON */
                    break;

                case MENU_LINENUM :
                    if(curFile != NULL)
                    {
                        LineNum ^= YES;
                        ResizeNumWindow();
                        ResizeViewWindow();
                        SetWindowSize();
                        SetScrollBar();
                    }
                    break;
            }
            break;

        case WM_US_EDIT_CLOSE :
            ReopenViewFromFile(ENCODE_AUTO);
            break;

        case WM_NOTIFY :
            switch(((LPNMHDR)lParam)->code)
            {
                /* c[`bvRg[bZ[W̏ */
                case TTN_NEEDTEXT:
                    lpttt = (LPTOOLTIPTEXT)lParam;
                    lpttt->hinst = hInstttPage;
                    switch(lpttt->hdr.idFrom)
                    {
                        case MENU_OPEN :
                            lpttt->lpszText = MSGJPN_7;
                            break;

                        case MENU_SAVEAS :
                            lpttt->lpszText = MSGJPN_9;
                            break;

                        case MENU_COPY :
                            lpttt->lpszText = MSGJPN_10;
                            break;

                        case MENU_PASTE :
                            lpttt->lpszText = MSGJPN_11;
                            break;

                        case MENU_FIND :
                            lpttt->lpszText = MSGJPN_12;
                            break;

                        case MENU_FINDNEXT :
                            lpttt->lpszText = MSGJPN_13;
                            break;

                        case MENU_FINDPREV :
                            lpttt->lpszText = MSGJPN_14;
                            break;

                        case MENU_FINDDISP :
                            lpttt->lpszText = MSGJPN_15;
                            break;

                        case MENU_EDITOR :
                            lpttt->lpszText = MSGJPN_16;
                            break;
                    }
                    break;
            }
            break;

        case WM_SIZE :
            if((wParam == SIZE_RESTORED) || (wParam == SIZE_MAXIMIZED))
            {
                ResizeWindowProc();
                if(curFile != NULL)
                {
                    SetWindowSize();
                    SetScrollBar();
                    SetDispTopWindowMatch();
                }
            }
            else
            {
                return(DefWindowProc(hWnd, message, wParam, lParam));
            }
            break;

#if 0
        case WM_MOUSEWHEEL95 :
            hdlMsWheel = FindWindow(MSH_WHEELMODULE_CLASS, MSH_WHEELMODULE_TITLE);

            wheelScroll = 3;
            if(puiMsh_MsgScrollLines != 0)
            {
                wheelScroll = (int)SendMessage(hdlMsWheel, puiMsh_MsgScrollLines, 0, 0);
            }

            if((short)LOWORD(wParam) < 0)
            {
                SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_NEXT_N_LINE, 0), wheelScroll);
            }
            else if((short)LOWORD(wParam) > 0)
            {
                SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_PREV_N_LINE, 0), wheelScroll);
            }
            break;
#endif

        case WM_MOUSEWHEEL :
            if(SystemParametersInfo(SPI_GETWHEELSCROLLLINES, 0, &wheelScroll, 0) == 0)
            {
                wheelScroll = 3;
            }

            if((short)HIWORD(wParam) < 0)
            {
                SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_NEXT_N_LINE, 0), wheelScroll);
            }
            else if((short)HIWORD(wParam) > 0)
            {
                SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_PREV_N_LINE, 0), wheelScroll);
            }
            break;

//      case WM_MOVING :
//          WinPosX = ((RECT *)lParam)->left;
//          WinPosY = ((RECT *)lParam)->top;
//          return(DefWindowProc(hWnd, message, wParam, lParam));

        case WM_WINDOWPOSCHANGED :
            if((IsZoomed(hWnd) == FALSE) && (IsIconic(hWnd) == FALSE))
            {
                GlobalSet.WinPosX = ((WINDOWPOS *)lParam)->x;
                GlobalSet.WinPosY = ((WINDOWPOS *)lParam)->y;
            }
            return(DefWindowProc(hWnd, message, wParam, lParam));

        case WM_DESTROY :
            PostQuitMessage(0);
            break;

        case WM_QUERYENDSESSION :
            ExitProc(hWnd);
            return(TRUE);

        case WM_CLOSE :
            ExitProc(hWnd);
            break;

        default :
            return(DefWindowProc(hWnd, message, wParam, lParam));
    }
    return(0L);
}


/*----- vOȈ ------------------------------------------------
*
*   Parameter
*       HWND hWnd : EChEnh
*
*   Return Value
*       Ȃ
*----------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------
Name    :   ExitProc
Desc    :   vOȈ
Param   :
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
static void ExitProc(HWND hWnd)
{
    AskWindowSize();
    if(SaveExit == YES)
    {
        SaveRegistory();
    }
    CoUninitialize();
    DeleteAllObject();
    HtmlHelp(NULL, NULL, HH_UNINITIALIZE, dwCookie);
    return;
}


/*-------------------------------------------------------------------------------
Name    :   AskWindowSize
Desc    :   EChẼTCY擾
Param   :   none
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
static void AskWindowSize(void)
{
    WINDOWPLACEMENT winPlace;

    winPlace.length = sizeof(WINDOWPLACEMENT);
    GetWindowPlacement(hWndttPage, &winPlace);
    GlobalSet.WinWidth = winPlace.rcNormalPosition.right - winPlace.rcNormalPosition.left;
    GlobalSet.WinHeight = winPlace.rcNormalPosition.bottom - winPlace.rcNormalPosition.top;

    GlobalSet.Maximize = NO;
    if(winPlace.showCmd == SW_SHOWMAXIMIZED)
    {
        GlobalSet.Maximize = YES;
    }
    return;
}


/*-------------------------------------------------------------------------------
Name    :   ResizeWindowProc
Desc    :   EChẼTCYύX̏
Param   :   none
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
static void ResizeWindowProc(void)
{
    ResizeStatusWin();
    ResizeToolBar();
    ResizeNumWindow();
    ResizeViewWindow();
    return;
}


/*-------------------------------------------------------------------------------
Name    :   AnalyzeComLine
Desc    :   R}hC
Param   :   str         R}hC
            filename    t@C
            option      IvV
            topLine     \擪s
Return  :   Xe[^X (SUCCESS/FAIL)
Note    :
-------------------------------------------------------------------------------*/
static int AnalyzeComLine(LPTSTR str, LPTSTR filename, int *option, int *topLine)
{
    int     sts;
    _TCHAR  tmp[MAX_PATH+1];

    _tcscpy(filename, _T(""));
    *option = 0;
    *topLine = 0;

    sts = SUCCESS;
    str = GetToken(str, tmp, NO);
    while((str = GetToken(str, tmp, YES)) != NULL)
    {
        if(tmp[0] == _T('-'))
        {
            _tcslwr(tmp);
            if((_tcscmp(&tmp[1], _T("j")) == 0) || (_tcscmp(&tmp[1], _T("-jump")) == 0))
            {
                if(((str = GetToken(str, tmp, NO)) != NULL) && (isdigit(*tmp)))
                {
                    *topLine = _ttoi(tmp)-1;
                }
                else
                {
                    DispErrorBox(MSGJPN_17);
                    sts = FAIL;
                    break;
                }
            }
            else if((_tcscmp(&tmp[1], _T("e")) == 0) || (_tcscmp(&tmp[1], _T("-jumpend")) == 0))
            {
                *topLine = -1;
            }
            else if((_tcscmp(&tmp[1], _T("h")) == 0) || (_tcscmp(&tmp[1], _T("-help")) == 0))
            {
                hWndHelp = HtmlHelp(NULL, AskHelpFilePath(), HH_HELP_CONTEXT, IDH_HELP_TOPIC_0000008);
            }
            else if(_tcscmp(&tmp[1], _T("-sjis")) == 0)
            {
                *option |= OPT_SJIS;
            }
            else if(_tcscmp(&tmp[1], _T("-jis")) == 0)
            {
                *option |= OPT_JIS;
            }
            else if(_tcscmp(&tmp[1], _T("-euc")) == 0)
            {
                *option |= OPT_EUC;
            }
            else if(_tcscmp(&tmp[1], _T("-utf16")) == 0)
            {
                *option |= OPT_UTF16;
            }
            else if(_tcscmp(&tmp[1], _T("-utf16be")) == 0)
            {
                *option |= OPT_UTF16BE;
            }
            else if(_tcscmp(&tmp[1], _T("-utf8")) == 0)
            {
                *option |= OPT_UTF8;
            }
            else if(_tcscmp(&tmp[1], _T("-utf7")) == 0)
            {
                *option |= OPT_UTF7;
            }
            else
            {
                DispErrorBox(MSGJPN_18, tmp);
                sts = FAIL;
                break;
            }
        }
        else
        {
            if(_tcslen(filename) == 0)
            {
                _tcscpy(filename, tmp);
            }
            else
            {
                DispErrorBox(MSGJPN_19, tmp);
                sts = FAIL;
                break;
            }
        }
    }
    return(sts);
}


/*-------------------------------------------------------------------------------
Name    :   GetToken
Desc    :   g[NԂ
Param   :   str     
            buf     [out] Ԃobt@
            flag    Xy[X܂ޖO邩ǂ (YES/NO)
Return  :   g[N
Note    :
-------------------------------------------------------------------------------*/
static LPTSTR GetToken(LPTSTR str, LPTSTR buf, int flag)
{
    int     inQueue;
    LPTSTR  btm;
    LPTSTR  strTop;

    while(*str != NUL)
    {
        if((*str != _T(' ')) && (*str != _T('\t')))
        {
            break;
        }
        str++;
    }

    if(*str != NUL)
    {
        if(*str == _T('-'))     /* IvV̓Xy[X͊܂܂Ȃ */
        {
            flag = NO;
        }

        strTop = str;
        inQueue = 0;
        while(*str != NUL)
        {
            if(*str == 0x22)
            {
                inQueue = !inQueue;
            }
            else
            {
                if(flag == YES)
                {
                    if((*str == _T('-')) && (inQueue == 0))
                    {
                        if((str == strTop) || (*(str-1) == _T(' ')))
                        {
                            break;
                        }
                    }
                    if((inQueue == 0) &&
                       ((*str == _T(' ')) || (*str == _T('\t'))))
                    {
                        *buf++ = *str;
                    }
                    else
                    {
                        *buf++ = *str;
                        btm = buf;
                    }
                }
                else
                {
                    if((inQueue == 0) &&
                       ((*str == _T(' ')) || (*str == _T('\t'))))
                    {
                        break;
                    }
                    *buf++ = *str;
                    btm = buf;
                }
            }
            str++;
        }
        *btm = NUL;
    }
    else
    {
        str = NULL;
    }
    return(str);
}


/*-------------------------------------------------------------------------------
Name    :   SetCurExtNum
Desc    :   ݂̃t@Cɑ΂t@C^Cvʐݒf[^ݒ肷
Param   :   none
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
void SetCurExtNum(void)
{
    int     i;
    LPTSTR  pos;
    LPTSTR  ext;

    ext = GetFileName(AskCurFileTbl()->Fname);
    CurExtSet = 0;
    for(i = GlobalSet.ExtSetNum-1; i > 0; i--)
    {
        pos = GlobalSet.ExtSetTbl[i].Exts;
        while(*pos != NUL)
        {
            if(CheckFname(ext, pos) == SUCCESS)
            {
                CurExtSet = i;
                break;
            }
            pos += _tcslen(pos) + 1;
        }
        if(CurExtSet != 0)
        {
            break;
        }
    }
    SetCurSetNumToCurSetWin();
    return;
}


/*-------------------------------------------------------------------------------
Name    :   AskCurExtSet
Desc    :   ݂̃t@C^Cvʐݒ̃f[^Ԃ
Param   :   none
Return  :   t@C^Cvʐݒf[^
Note    :
-------------------------------------------------------------------------------*/
EXTSET *AskCurExtSet(void)
{
    return(&GlobalSet.ExtSetTbl[CurExtSet]);
}


/*-------------------------------------------------------------------------------
Name    :   AskCurExtSetNum
Desc    :   ݂̃t@C^CvʐݒԍԂ
Param   :   none
Return  :   t@C^Cvʐݒԍ
Note    :
-------------------------------------------------------------------------------*/
int AskCurExtSetNum(void)
{
    return(CurExtSet);
}


/*-------------------------------------------------------------------------------
Name    :   SaveFileAs
Desc    :   t@Cۑ
Param   :   tbl     t@CǗe[u
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
static void SaveFileAs(FILEMANTBL *tbl)
{
    _TCHAR      filename[MAX_PATH+1];
    FILE        *strm;
    WORD        bom;

    _tcscpy(filename, _T(""));
    if(SelectFileToSave(hWndttPage, filename, MSGJPN_20, _T(""), _T("")) == TRUE)
    {
        if((strm = _tfopen(filename, _T("wb"))) != NULL)
        {
            bom = 0xFEFF;
            fwrite(&bom, sizeof(WORD), 1, strm);
            fwrite(tbl->TextData, tbl->TextSize * sizeof(_TCHAR), 1, strm);
            fclose(strm);
        }
    }
    return;
}


/*-------------------------------------------------------------------------------
Name    :   RingErrorBell
Desc    :   G[̃x炷
Param   :   none
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
void RingErrorBell(void)
{
    if(GlobalSet.ErrBell == YES)
    {
        MessageBeep(-1);
    }
    return;
}


/*-------------------------------------------------------------------------------
Name    :   DispErrorBox
Desc    :   G[bZ[W{bNX\
Param   :   szFormat ...    tH[}bgt
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
void DispErrorBox(LPTSTR szFormat,...)
{
    va_list         vaArgs;
    static _TCHAR   szBuf[256];

    va_start(vaArgs,szFormat);
    if(_vstprintf(szBuf,szFormat,vaArgs)!=EOF)
    {
        MessageBox(NULL, szBuf, _T("ttPage"), MB_OK);
    }
    va_end(vaArgs);
}


/*-------------------------------------------------------------------------------
Name    :   AboutDialogProc
Desc    :   uttPageɂāv_CAŐʃR[obN֐
Param   :   hDlg        EChEnh
            message     bZ[Wԍ
            wParam      bZ[W WPARAM 
            lParam      bZ[W LPARAM 
Return  :   BOOL
Note    :
-------------------------------------------------------------------------------*/
static BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG :
            return(TRUE);

        case WM_COMMAND :
            switch(GET_WM_COMMAND_ID(wParam, lParam))
            {
                case IDOK :
                    EndDialog(hDlg, YES);
                    break;

                case IDCANCEL :
                    EndDialog(hDlg, NO);
                    break;
            }
            return(TRUE);
    }
    return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :   LoadDefaultExtSet
Desc    :   t@C^Cvʐݒ̃ftHgl[h
Param   :   tbl     [out] ftHgl
Return  :   none
Note    :
-------------------------------------------------------------------------------*/
void LoadDefaultExtSet(EXTSET *tbl)
{
    memcpy(tbl, &DefaultExtSetTbl[0], sizeof(EXTSET));
    _tcscpy(tbl->Name, _T(""));
    return;
}


