/*===========================================================================
/
/									ttPage
/							̑̔ėpTu[`
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <tchar.h>
#include <dlgs.h>

#include "common.h"
#include "resource.h"


/*===== ̓_CAOf[^̃XgN` =====*/

typedef struct {
	_TCHAR	Title[80];			/* _CAÕ^Cg */
	_TCHAR	String[MAX_PATH+1];	/* ftHg^͂ꂽ(Output) */
	int		MaxLength;			/* ̍Œ */
	int		CheckBox;			/* `FbN{bNX̏ */
} DIALOGDATA;

/*===== vg^Cv =====*/

static BOOL CALLBACK InputDialogCallBack(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static UINT CALLBACK OpenHookProc(HWND hDlg, UINT message, WPARAM wParam,LPARAM lParam);

/*===== [Jȃ[N =====*/

static DIALOGDATA *DialogData;		/* ̓_CAOf[^ */
static int OpenCustomEncode;


/*-------------------------------------------------------------------------------
Name    :	InputDialogBox
Desc    :	̓_CAO\
Param   :	resourceId	_CAO{bNXID
			hWnd		eEChẼEChEnh
			title		EChE^Cg (NULL=ݒ肵Ȃ)
			buf			[in/out]GfBbg{bNX̏^͕
			bufSize		obt@̃TCY (MAX_PATH+1ȉł邱)
			check		[in/out] `FbN{bNX̏l^ݒl
Return  :	Xe[^X (YES/NO=)
Note    :	
-------------------------------------------------------------------------------*/
int InputDialogBox(int resourceId, HWND hWnd, LPTSTR title, LPTSTR buf, int bufSize, int *check)
{
	int			ret;
	DIALOGDATA	dData;

	dData.MaxLength = bufSize;
	memset(dData.String, NUL, MAX_PATH+1);
	_tcsncpy(dData.String, buf, MAX_PATH);
	_tcscpy(dData.Title, _T(""));
	if(title != NULL)
	{
		_tcscpy(dData.Title, title);
	}
	dData.CheckBox = *check;
	DialogData = &dData;

	ret = DialogBox(GetProgInst(), MAKEINTRESOURCE(resourceId), hWnd, InputDialogCallBack);

	if(ret == YES)
	{
		memset(buf, NUL, bufSize);
		_tcsncpy(buf, dData.String, bufSize-1);
		*check = dData.CheckBox;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	InputDialogCallBack
Desc    :	̓_CAÕR[obN
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	Xe[^X (TRUE/FALSE)
Note    :	
-------------------------------------------------------------------------------*/
static BOOL CALLBACK InputDialogCallBack(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG :
			if(_tcslen(DialogData->Title) != 0)
			{
				SendMessage(hDlg, WM_SETTEXT, 0, (LPARAM)DialogData->Title);
			}
			SendDlgItemMessage(hDlg, INP_TEXT, EM_LIMITTEXT, DialogData->MaxLength-1, 0);
			SendDlgItemMessage(hDlg, INP_TEXT, WM_SETTEXT, 0, (LPARAM)DialogData->String);
			SendDlgItemMessage(hDlg, INP_CHECK1, BM_SETCHECK, DialogData->CheckBox, 0);
			return(TRUE);

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case IDOK :
					SendDlgItemMessage(hDlg, INP_TEXT, WM_GETTEXT, DialogData->MaxLength, (LPARAM)DialogData->String);
					DialogData->CheckBox = SendDlgItemMessage(hDlg, INP_CHECK1, BM_GETCHECK, 0, 0);
					EndDialog(hDlg, YES);
					break;

				case IDCANCEL :
					EndDialog(hDlg, NO);
					break;
			}
            return(TRUE);
	}
	return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :	ExeEscDialogProc
Desc    :	msnƁmñ_CAŐʃR[obN֐
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	Xe[^X (TRUE/FALSE)
Note    :	
-------------------------------------------------------------------------------*/
BOOL CALLBACK ExeEscDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG :
			return(TRUE);

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case IDOK :
					EndDialog(hDlg, YES);
					break;

				case IDCANCEL :
					EndDialog(hDlg, NO);
					break;
			}
			return(TRUE);
	}
    return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :	ExeEscMsgDialogProc
Desc    :	msnƁmñ_CAŐʃR[obN֐ibZ[W\j
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	Xe[^X (TRUE/FALSE)
Note    :	
-------------------------------------------------------------------------------*/
BOOL CALLBACK ExeEscMsgDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, DLG_MSG1, WM_SETTEXT, 0, lParam);
			return(TRUE);

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case IDOK :
					EndDialog(hDlg, YES);
					break;

				case IDCANCEL :
					EndDialog(hDlg, NO);
					break;
			}
			return(TRUE);
	}
    return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :	SetYenTail
Desc    :	̍Ō \ t
Param   :	str		
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void SetYenTail(LPTSTR str)
{
	if(_tcscmp(_tcsninc(str, _tcslen(str) - 1), _T("\\")) != 0)
	{
		_tcscat(str, _T("\\"));
	}
	return;;
}


#if 0
/*----- 񂩂sR[h菜 ----------------------------------------
*
*	Parameter
*		LPTSTR str : 
*
*	Return Value
*		Ȃ
*
*	Note
*		IWi̕ LPTSTR str ύX܂B
*----------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------
Name    :	RemoveReturnCode
Desc    :	
Param   :	
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void RemoveReturnCode(LPTSTR str)
{
	LPTSTR pos;

	if((pos = _tcschr(str, 0x0D)) != NULL)
		*pos = NUL;

	if((pos = _tcschr(str, 0x0A)) != NULL)
		*pos = NUL;
	return;
}
#endif


/*-------------------------------------------------------------------------------
Name    :	AskMultiStrLen
Desc    :	AC̒߂
Param   :	mulStr		AC (NULQ)
Return  :	
Note    :	I[2NUL̂̍Ō͐̕Ȃ
				AskMultiStrLen(_T("")) = 0
				AskMultiStrLen(_T("abc\0xyz\0")) = 8
				AskMultiStrLen(_T("abc")) = I[QNULłȂ̂ŋ߂Ȃ
-------------------------------------------------------------------------------*/
int AskMultiStrLen(LPTSTR mulStr)
{
	int		len;
	int		tmp;

	len = 0;
	while(*mulStr != NUL)
	{
		tmp = _tcslen(mulStr) + 1;
		mulStr += tmp;
		len += tmp;
	}
	return(len);
}


/*-------------------------------------------------------------------------------
Name    :	CountMultiStrNum
Desc    :	AC̒̐̕𐔂
Param   :	mulStr		AC (NULQ)
Return  :	
Note    :	
-------------------------------------------------------------------------------*/
int CountMultiStrNum(LPTSTR mulStr)
{
	int		ret;

	ret = 0;
	if(*mulStr != NUL)
	{
		while(*mulStr != NUL)
		{
			ret++;
			mulStr += _tcslen(mulStr) + 1;
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	InsertStrToMultiStr
Desc    :	AC̐擪ɕ}
Param   :	str			
			mulStr		AC (NULQ)
			bufSize		ACi[obt@̃TCY
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int InsertStrToMultiStr(LPTSTR str, LPTSTR mulStr, int bufSize)
{
	int		mulLen;
	int		strLen;
	int		sts;

	sts = FAIL;
	mulLen = AskMultiStrLen(mulStr);
	strLen = _tcslen(str);
	if(mulLen + strLen + 1 <= bufSize)
	{
		memmove(mulStr+strLen+1, mulStr, mulLen+1);
		_tcscpy(mulStr, str);
		sts = SUCCESS;
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	DeleteStrFromMultiStr
Desc    :	AC̒̎w̕폜
Param   :	str			
			mulStr		AC (NULQ)
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int DeleteStrFromMultiStr(LPTSTR str, LPTSTR mulStr)
{
	int		sts;
	LPTSTR	pos;

	sts = FAIL;

	pos = mulStr;
	while(*pos != NUL)
	{
		if(_tcscmp(pos, str) == 0)
		{
			mulStr = _tcschr(pos, _T('\0')) + 1;
			memmove(pos, mulStr, AskMultiStrLen(mulStr)+1);
			sts = SUCCESS;
			break;
		}
		pos += _tcslen(pos) + 1;
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	DeleteNumFromMultiStr
Desc    :	AC̒̎wԍ̕폜
Param   :	num			ԍ
			mulStr		AC (NULQ)
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int DeleteNumFromMultiStr(int num, LPTSTR mulStr)
{
	int		sts;
	LPTSTR	pos;

	sts = FAIL;

	pos = mulStr;
	while(*pos != NUL)
	{
		if(num == 0)
		{
			mulStr = _tcschr(pos, _T('\0')) + 1;
			memmove(pos, mulStr, AskMultiStrLen(mulStr)+1);
			sts = SUCCESS;
			break;
		}
		pos += _tcslen(pos) + 1;
		num--;
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	GetStrLenOfCopyToClipboard
Desc    :	Nbv{[hɃRs[f[^̒߂
Param   :	str		
			len		̒̕iNUL͖j
			quote	p
Return  :	
Note    :	
-------------------------------------------------------------------------------*/
int GetStrLenOfCopyToClipboard(LPTSTR str, int len, LPTSTR quote)
{
	int		ret;
	int		Top;
	int		quoteLen;

	quoteLen = _tcslen(quote);
	Top = YES;
	ret = 0;
	for(; len > 0; len--)
	{
		if(Top == YES)
		{
			ret += quoteLen;
		}
		Top = NO;

		if(*str == _T('\r'))
		{
			ret += 2;
			if((len > 1) && (*(str+1) == _T('\n')))
			{
				/* CR+LF */
				str++;
				len--;
			}
			Top = YES;
		}
		else if(*str == _T('\n'))
		{
			/* Only LF */
			ret += 2;
			Top = YES;
		}
		else
		{
			ret++;
		}
		str++;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	CopyStrToClipboard
Desc    :	Nbv{[hɃRs[
Param   :	buf		Rs[
			str		
			len		̒iNUL͖j
			quote	p
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void CopyStrToClipboard(LPTSTR buf, LPTSTR str, int len, LPTSTR quote)
{
	int		Top;
	int		quoteLen;

	quoteLen = _tcslen(quote);
	Top = YES;
	for(; len > 0; len--)
	{
		if(Top == YES)
		{
			_tcscpy(buf, quote);
			buf += quoteLen;
		}
		Top = NO;

		if(*str == _T('\r'))
		{
			*buf++ = _T('\r');
			*buf++ = _T('\n');

			if((len > 1) && (*(str+1) == '\n'))
			{
				str++;
				len--;
			}
			str++;
			Top = YES;
		}
		else if(*str == _T('\n'))
		{
			*buf++ = _T('\r');
			*buf++ = _T('\n');
			str++;
			Top = YES;
		}
		else
		{
			*buf++ = *str++;
		}
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetFileName
Desc    :	pX̒̃t@C̐擪Ԃ
Param   :	path		pX
Return  :	t@C̐擪
Note    :	fBNg̋؂L "\"  "/" ̗L
-------------------------------------------------------------------------------*/
LPTSTR GetFileName(LPTSTR path)
{
	LPTSTR		pos;

	if((pos = _tcschr(path, _T(':'))) != NULL)
	{
		path = pos + 1;
	}
	if((pos = _tcsrchr(path, _T('\\'))) != NULL)
	{
		path = pos + 1;
	}
	if((pos = _tcsrchr(path, _T('/'))) != NULL)
	{
		path = pos + 1;
	}
	return(path);
}


/*-------------------------------------------------------------------------------
Name    :	GetFileExt
Desc    :	pX̒̊gq̐擪Ԃ
Param   :	path		pX
Return  :	gq̐擪
Note    :	
-------------------------------------------------------------------------------*/
LPTSTR GetFileExt(LPTSTR path)
{
	LPTSTR		ret;

	ret = _tcschr(path, NUL);
	if((_tcscmp(path, _T(".")) != 0) &&
	   (_tcscmp(path, _T("..")) != 0))
	{
		while((path = _tcschr(path, _T('.'))) != NULL)
		{
			path++;
			ret = path;
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	RemoveFileName
Desc    :	pXt@C菜
Param   :	path	pX
			buf		t@CpX̃Rs[
Return  :	none
Note    :	fBNg̋؂L "\"  "/" ̗L
-------------------------------------------------------------------------------*/
void RemoveFileName(LPTSTR path, LPTSTR buf)
{
	LPTSTR		pos;

	_tcscpy(buf, path);

	if((pos = _tcsrchr(buf, _T('/'))) != NULL)
	{
		*pos = NUL;
	}
	else if((pos = _tcsrchr(buf, _T('\\'))) != NULL)
	{
		if((pos == buf) || 
		   ((pos != buf) && (*(pos - 1) != _T(':'))))
		{
			*pos = NUL;
		}
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	SelectFileToOpenEx
Desc    :	t@CIiuJvpAGR[hw肠j
Param   :	hWnd		EChEnh
			filename	[out] t@C
			title		^Cg
			filters		tB^[
			extension	ftHggq
			encode		[out] GR[h̎w
Return  :	Xe[^X (TRUE/FALSE=)
Note    :	
-------------------------------------------------------------------------------*/
int SelectFileToOpenEx(HWND hWnd, LPTSTR filename, LPTSTR title, LPTSTR filters, LPTSTR extension, int *encode)
{
	OPENFILENAME	openFile;
	_TCHAR			tmp[MAX_PATH+1];
	int				sts;

	OpenCustomEncode = ENCODE_AUTO;
	_tcscpy(tmp, filename);
	openFile.lStructSize = sizeof(OPENFILENAME);
	openFile.hwndOwner = hWnd;
	openFile.hInstance = GetProgInst();
	openFile.lpstrFilter = filters;
	openFile.lpstrCustomFilter = NULL;
	openFile.nFilterIndex = 1;
	openFile.lpstrFile = tmp;
	openFile.nMaxFile = MAX_PATH;
	openFile.lpstrFileTitle = NULL;
	openFile.nMaxFileTitle = 0;
	openFile.lpstrInitialDir = NULL;
	openFile.lpstrTitle = title;
	openFile.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_EXPLORER | OFN_ENABLESIZING | OFN_ENABLEHOOK | OFN_ENABLETEMPLATE;
	openFile.nFileOffset = 0;
	openFile.nFileExtension = 0;
	openFile.lpstrDefExt = extension;
	openFile.lCustData = 0;
	openFile.lpfnHook = OpenHookProc;
	openFile.lpTemplateName = MAKEINTRESOURCE(open_custom_dlg);

	if((sts = GetOpenFileName(&openFile)) == TRUE)
	{
		_tcscpy(filename,tmp);
		*encode = OpenCustomEncode;
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	OpenHookProc
Desc    :	JEChẼtbN֐
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	UINT
Note    :	
-------------------------------------------------------------------------------*/
static UINT CALLBACK OpenHookProc(HWND hDlg, UINT message, WPARAM wParam,LPARAM lParam)
{
	int					index;
	static const int	encodeTable[] = {
		ENCODE_AUTO,		ENCODE_UTF16_CHECK,		ENCODE_UTF16_BE_CHECK,
		ENCODE_UTF8_CHECK,	ENCODE_UTF7_NOBOM,		ENCODE_SJIS,
		ENCODE_EUC,			ENCODE_JIS
	};

	switch(message)
	{
		case WM_INITDIALOG:
			/* GR[h̎ނZbg */
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_86);
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_87);
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_88);
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_89);
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_90);
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_91);
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_92);
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_93);
			SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_SETCURSEL, 0, 0);
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case OPEN_CUSTOM_ENCODE :
					if(HIWORD(wParam) == CBN_SELCHANGE)
					{
						/* I΂ꂽ_Ń[NɕۑĂ */
						index = SendDlgItemMessage(hDlg, OPEN_CUSTOM_ENCODE, CB_GETCURSEL, 0, 0);
						if((index >= 0) && (index <= 7))
						{
							OpenCustomEncode = encodeTable[index];
						}
					}
					return TRUE;
			}
			break;
	}
	return(FALSE);
}



/*-------------------------------------------------------------------------------
Name    :	SelectFileToOpen
Desc    :	t@CIiuJvpAėpj
Param   :	hWnd		EChEnh
			filename	[out] t@C
			title		^Cg
			filters		tB^[
			extension	ftHggq
Return  :	Xe[^X (TRUE/FALSE=)
Note    :	
-------------------------------------------------------------------------------*/
int SelectFileToOpen(HWND hWnd, LPTSTR filename, LPTSTR title, LPTSTR filters, LPTSTR extension)
{
	OPENFILENAME	openFile;
	_TCHAR			tmp[MAX_PATH+1];
	int				sts;

	_tcscpy(tmp, filename);
	openFile.lStructSize = sizeof(OPENFILENAME);
	openFile.hwndOwner = hWnd;
	openFile.hInstance = 0;
	openFile.lpstrFilter = filters;
	openFile.lpstrCustomFilter = NULL;
	openFile.nFilterIndex = 1;
	openFile.lpstrFile = tmp;
	openFile.nMaxFile = MAX_PATH;
	openFile.lpstrFileTitle = NULL;
	openFile.nMaxFileTitle = 0;
	openFile.lpstrInitialDir = NULL;
	openFile.lpstrTitle = title;
	openFile.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
	openFile.nFileOffset = 0;
	openFile.nFileExtension = 0;
	openFile.lpstrDefExt = extension;
	openFile.lCustData = 0;
	openFile.lpfnHook = NULL;
	openFile.lpTemplateName = NULL;

	if((sts = GetOpenFileName(&openFile)) == TRUE)
	{
		_tcscpy(filename,tmp);
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	SelectFileToSave
Desc    :	t@CIiuۑvpj
Param   :	hWnd		EChEnh
			filename	[out] t@C
			title		^Cg
			filters		tB^[
			extension	ftHggq
Return  :	Xe[^X (TRUE/FALSE=)
Note    :	
-------------------------------------------------------------------------------*/
int SelectFileToSave(HWND hWnd, LPTSTR filename, LPTSTR title, LPTSTR filters, LPTSTR extension)
{
	OPENFILENAME	openFile;
	_TCHAR			tmp[MAX_PATH+1];
	int				sts;

	_tcscpy(tmp, filename);
	openFile.lStructSize = sizeof(OPENFILENAME);
	openFile.hwndOwner = hWnd;
	openFile.hInstance = GetProgInst();
	openFile.lpstrFilter = filters;
	openFile.lpstrCustomFilter = NULL;
	openFile.nFilterIndex = 1;
	openFile.lpstrFile = tmp;
	openFile.nMaxFile = MAX_PATH;
	openFile.lpstrFileTitle = NULL;
	openFile.nMaxFileTitle = 0;
	openFile.lpstrInitialDir = NULL;
	openFile.lpstrTitle = title;
	openFile.Flags = OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT;
	openFile.nFileOffset = 0;
	openFile.nFileExtension = 0;
	openFile.lpstrDefExt = extension;
	openFile.lCustData = 0;
	openFile.lpfnHook = NULL;
	openFile.lpTemplateName = NULL;

	if((sts = GetSaveFileName(&openFile)) == TRUE)
	{
		_tcscpy(filename,tmp);
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	SetRadioButtonByValue
Desc    :	lɊ֘AtꂽWI{^`FbN
Param   :	hDlg		_CAO{bNX̃EChEnh
			value		l
			buttons		WI{^ƒl̊֘Ate[u
			num			{^̐
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void SetRadioButtonByValue(HWND hDlg, int value, const RADIOBUTTON *buttons, int num)
{
	int		i;
	int		def;
	int		found;

	found = NO;
	def = buttons->ButID;
	for(i = 0; i < num; i++)
	{
		if(value == buttons->Value)
		{
			SendDlgItemMessage(hDlg, buttons->ButID, BM_SETCHECK, 1, 0);
			/* WI{^ύXɑ̍ڂ̃nChȂǂsȂ	*/
			/* ̂ŁÂ߂ WM_COMMAND 𑗂 						*/
			SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(buttons->ButID, 0), 0);
			found = YES;
		}
		else
		{
			SendDlgItemMessage(hDlg, buttons->ButID, BM_SETCHECK, 0, 0);
		}
		buttons++;
	}

	if(found == NO)
	{
		SendDlgItemMessage(hDlg, def, BM_SETCHECK, 1, 0);
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(def, 0), 0);
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	AskRadioButtonValue
Desc    :	`FbNĂ{^Ɋ֘AtꂽlԂ
Param   :	hDlg		_CAO{bNX̃EChEnh
			buttons		WI{^ƒl̊֘Ate[u
			num			{^̐
Return  :	WI{^̒l
Note    :	
-------------------------------------------------------------------------------*/
int AskRadioButtonValue(HWND hDlg, const RADIOBUTTON *buttons, int num)
{
	int		i;
	int		ret;

	ret = buttons->Value;
	for(i = 0; i < num; i++)
	{
		if(SendDlgItemMessage(hDlg, buttons->ButID, BM_GETCHECK, 0, 0) == 1)
		{
			ret = buttons->Value;
			break;
		}
		buttons++;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	DoPrintf
Desc    :	fobOR\[ɃbZ[W\
Param   :	szFormat ...	tH[}bgt
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void DoPrintf(LPTSTR szFormat, ...)
{
	va_list			vaArgs;
	static _TCHAR	szBuf[256];
	DWORD			tmp;

	va_start(vaArgs,szFormat);
	if(_vstprintf(szBuf,szFormat,vaArgs)!=EOF)
	{
		WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), szBuf, _tcslen(szBuf), &tmp, NULL);
	}
	va_end(vaArgs);
}


/*-------------------------------------------------------------------------------
Name    :	MoveFileToTrashCan
Desc    :	t@CS~ɍ폜
Param   :	path		t@C
Return  :	Xe[^X (0=)
Note    :	
-------------------------------------------------------------------------------*/
int MoveFileToTrashCan(LPTSTR path)
{
	SHFILEOPSTRUCT	fileOp;
	_TCHAR			tmp[MY_MAX_PATH+2];

	memset(tmp, 0, (MY_MAX_PATH+2) * sizeof(_TCHAR));
	_tcscpy(tmp, path);
	fileOp.hwnd = NULL;
	fileOp.wFunc = FO_DELETE;
	fileOp.pFrom = tmp;
	fileOp.pTo = _T("");
	fileOp.fFlags = FOF_SILENT | FOF_NOCONFIRMATION | FOF_ALLOWUNDO;
	fileOp.lpszProgressTitle = _T("");
	return(SHFileOperation(&fileOp));
}


/*-------------------------------------------------------------------------------
Name    :	Malloc
Desc    :	malloc̃G[`FbN
Param   :	size	mۂTCY
Return  :	ubN
Note    :	mۂłȂƂ̓vOI
-------------------------------------------------------------------------------*/
void *Malloc(size_t size)
{
	void	*block;

	block = malloc(size);
	if(block == NULL)
	{
		MessageBox(NULL, MSGJPN_94, _T("ttPage"), MB_ICONSTOP|MB_OK);
		ExitProcess(1);		/* force exit */
	}
	return(block);
}


/*-------------------------------------------------------------------------------
Name    :	Realloc
Desc    :	realloc̃G[`FbN
Param   :	block	ubN
			size	ύX̃TCY
Return  :	ubN
Note    :	mۂłȂƂ̓vOI
-------------------------------------------------------------------------------*/
void *Realloc(void *block, size_t size)
{
	block = realloc(block, size);
	if(block == NULL)
	{
		MessageBox(NULL, MSGJPN_94, _T("ttPage"), MB_ICONSTOP|MB_OK);
		ExitProcess(1);		/* force exit */
	}
	return(block);
}


