/*===========================================================================
/
/									ttPage
/							t@C^Cvʐݒ
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <windowsx.h>
#include <commctrl.h>
#include <htmlhelp.h>

#include "common.h"
#include "resource.h"



typedef struct {
	const _TCHAR	*Title;			/* y[W̃^Cg */
	int				ResourceId;		/* _CAÕ\[XID */
	int				HelpId;			/* wvID */
	DLGPROC			WndProc;		/* EChEvV[W */
	int				ItemLevel;		/* ACẽx */
	HWND			hWndSheet;		/* _CAÕEChEnh */
	HTREEITEM		ItemId;			/* TreeView̃ACeID */
} TREEPROPSHEET;


/*===== vg^Cv =====*/

static LRESULT CALLBACK PropSheetFrameWndProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static void SetExtSetToDialog(HWND hDlg, EXTSET *tbl, int num);
static void GetExtSetFromDialog(HWND hDlg, EXTSET *tbl, int num);
static void SetExtSetHide(HWND hDlg, int num);
static void SetDecimalText(HWND hDlg, int ctrl, int num);
static int GetDecimalText(HWND hDlg, int ctrl);
static LRESULT CALLBACK FnameSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static LRESULT CALLBACK ColorSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static int SelectColor(HWND hWnd, COLORREF *color, EXTSET *tbl, int num);
static int SerDefinedColor(int num, COLORREF *tbl, COLORREF color);
static void DrawColorButton(DRAWITEMSTRUCT *dItem, COLORREF color);
static LRESULT CALLBACK ToolSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

/*===== [Jȃ[N ======*/

static int Apply;

static TREEPROPSHEET SheetInfo[] = {
	{ MSGJPN_0,	patset_filename_dlg,	IDH_HELP_TOPIC_0000019,	FnameSettingProc,	0,	NULL,	NULL },
	{ MSGJPN_1,	patset_disp_dlg,		IDH_HELP_TOPIC_0000020,	ColorSettingProc,	0,	NULL,	NULL },
	{ MSGJPN_2,	patset_tool_dlg,		IDH_HELP_TOPIC_0000021,	ToolSettingProc,	0,	NULL,	NULL },
};


/*===== O[oȃ[N ======*/


static const RADIOBUTTON LineNumButton[] = {
	{ EXT_WPTYPE, LINENUM_WP },
	{ EXT_EDITORTYPE, LINENUM_EDITOR }
};
#define LINENUMBUTTONS	(sizeof(LineNumButton)/sizeof(RADIOBUTTON))


static const RADIOBUTTON ToolTypeButton[] = {
	{ TOOL_ASSOC, TOOL_TYPE_ASSOC },
	{ TOOL_SPECIFIED, TOOL_TYPE_SPECIFIED }
};
#define TOOLTYPEBUTTONS	(sizeof(ToolTypeButton)/sizeof(RADIOBUTTON))


static COLORREF TmpTextColor;
static COLORREF TmpHighColor;
static COLORREF TmpBackColor;
static COLORREF TmpCtrlColor;
static COLORREF TmpFindColor;
static COLORREF TmpCrColor;
static COLORREF TmpTabColor;
static COLORREF TmpHanSpcColor;
static COLORREF TmpZenSpcColor;

static LOGFONT TmpLogFont;

static EXTSET *TmpExtSetTbl;
static int TmpExtSetNum;
static int TmpExtSetMax;


/*===== OQ =====*/

GLOBALSET	GlobalSet;			/* ݒl */

extern int CurExtSet;
extern HWND hWndHelp;


/*-------------------------------------------------------------------------------
Name    :	DispPatSetDlg
Desc    :	p^[ݒ
Param   :	hWnd		eEChE
Return  :	Xe[^X (YES/NO=)
Note    :	
-------------------------------------------------------------------------------*/
int DispPatSetDlg(HWND hWnd)
{
	return(DialogBox(GetProgInst(), MAKEINTRESOURCE(patset_frame_dlg), hWnd, PropSheetFrameWndProc));
}


/*-------------------------------------------------------------------------------
Name    :	PropSheetFrameWndProc
Desc    :	p^[ݒt[_CAÕbZ[W
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	LRESULT
Note    :	
-------------------------------------------------------------------------------*/
static LRESULT CALLBACK PropSheetFrameWndProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT				rt;
	LPPOINT				pt = (LPPOINT) &rt;
	TV_INSERTSTRUCT		tvIns;
	NM_TREEVIEW			*treeView;
	int					i;
	static NMHDR		pnmhdr;
	static HWND			g_hTabCtrl;
	static int			curPage;
	HTREEITEM			hLevelItem[3];	/* SheetInfoŎw肳Ăő僌x+2ȏɐݒ肷邱 */
	int					num;
	_TCHAR				tmp[EXT_EXT_LEN+1];
	static int			tmpCurExtSet;

	#define PROP_PAGES	(sizeof(SheetInfo) / sizeof(TREEPROPSHEET))

	switch(message)
	{
		case WM_INITDIALOG :
			/* Make Tree and Pages */
			curPage = 0;
			SendMessage(hDlg, WM_SETTEXT, 0, (LPARAM)MSGJPN_41);

			hLevelItem[0] = TVI_ROOT;
			for(i = 0; i < PROP_PAGES; i++)
			{
				tvIns.hParent = hLevelItem[SheetInfo[i].ItemLevel];
				tvIns.hInsertAfter = TVI_LAST;
				tvIns.item.mask =  TVIF_TEXT | TVIF_PARAM;
				tvIns.item.pszText = (_TCHAR*)SheetInfo[i].Title;
				tvIns.item.lParam = i;
				SheetInfo[i].ItemId = (HTREEITEM)SendDlgItemMessage(hDlg, PATSET_TREE, TVM_INSERTITEM, 0, (LPARAM)&tvIns);
				hLevelItem[SheetInfo[i].ItemLevel + 1] = SheetInfo[i].ItemId;
			}
#if 0
			for(i = 0; i < PROP_PAGES; i++)
			{
				SendDlgItemMessage(hDlg, PATSET_TREE, TVM_EXPAND, TVE_EXPAND, (LPARAM)SheetInfo[i].ItemId);
			}
#endif
			SendDlgItemMessage(hDlg, PATSET_TREE, TVM_SELECTITEM, TVGN_CARET, (LPARAM)SheetInfo[0].ItemId);

			g_hTabCtrl = GetDlgItem(hDlg, PATSET_DIALOG_POS);
			GetClientRect(g_hTabCtrl, &rt);
			MapWindowPoints(g_hTabCtrl, hDlg, pt, 2);
			for(i = 0; i < PROP_PAGES; i++)
			{
				SheetInfo[i].hWndSheet = CreateDialog(GetProgInst(), MAKEINTRESOURCE(SheetInfo[i].ResourceId), hDlg, SheetInfo[i].WndProc);
				MoveWindow(SheetInfo[i].hWndSheet, rt.left, rt.top, rt.right - rt.left, rt.bottom - rt.top, FALSE);
			}

			/* Set list of settings */
			TmpExtSetNum = GlobalSet.ExtSetNum;
			TmpExtSetMax = GlobalSet.ExtSetMax;
			tmpCurExtSet = CurExtSet;
			TmpExtSetTbl = Malloc(TmpExtSetMax * sizeof(EXTSET));
			memcpy(TmpExtSetTbl, GlobalSet.ExtSetTbl, TmpExtSetNum * sizeof(EXTSET));
			for(i = 0; i < TmpExtSetNum; i++)
			{
				SendDlgItemMessage(hDlg, EXT_NAME, CB_ADDSTRING, 0, (LPARAM)TmpExtSetTbl[i].Name);
			}
			SendDlgItemMessage(hDlg, EXT_NAME, CB_SETCURSEL, tmpCurExtSet, 0);

			/* Send data to each page */
			SetExtSetToDialog(hDlg, TmpExtSetTbl, tmpCurExtSet);
			SetExtSetHide(hDlg, tmpCurExtSet);

			ShowWindow(SheetInfo[0].hWndSheet, SW_SHOW);
			SetFocus(GetDlgItem(hDlg, EXT_NAME));

			return FALSE;

		case WM_NOTIFY:
			treeView = (NM_TREEVIEW FAR *)lParam;
			switch(treeView->hdr.idFrom)
			{
				case PATSET_TREE :
					switch(treeView->hdr.code)
					{
// for unicows.dll
//						case TVN_SELCHANGED :
						case TVN_SELCHANGEDA :
						case TVN_SELCHANGEDW :
							curPage = treeView->itemNew.lParam;
							for(i = 0; i < PROP_PAGES; i++)
							{
								if(i == treeView->itemNew.lParam)
									ShowWindow(SheetInfo[i].hWndSheet, SW_SHOW);
								else
									ShowWindow(SheetInfo[i].hWndSheet, SW_HIDE);
							}
					}
			}
			break;

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case EXT_NAME :
					if(HIWORD(wParam) == CBN_SELCHANGE)
					{
						num = SendDlgItemMessage(hDlg, EXT_NAME, CB_GETCURSEL, 0, 0);
						GetExtSetFromDialog(hDlg, TmpExtSetTbl, tmpCurExtSet);
						tmpCurExtSet = num;
						SetExtSetToDialog(hDlg, TmpExtSetTbl, tmpCurExtSet);
						SetExtSetHide(hDlg, tmpCurExtSet);
					}
					break;

				case EXT_NEW :
					if(TmpExtSetNum >= TmpExtSetMax)
					{
						TmpExtSetMax += EXT_NUM_STEP;
						TmpExtSetTbl = Realloc(TmpExtSetTbl, TmpExtSetMax * sizeof(EXTSET));
					}

					_tcscpy(tmp, _T(""));
					if(InputDialogBox(newset_dlg, hDlg, MSGJPN_28, tmp, EXT_NAME_LEN+1, &i) == YES)
					{
						LoadDefaultExtSet(&TmpExtSetTbl[TmpExtSetNum]);
						tmpCurExtSet = TmpExtSetNum;
						TmpExtSetNum++;
						SendDlgItemMessage(hDlg, EXT_NAME, CB_ADDSTRING, 0, (LPARAM)tmp);
						SendDlgItemMessage(hDlg, EXT_NAME, CB_SETCURSEL, tmpCurExtSet, 0);
						_tcscpy(TmpExtSetTbl[tmpCurExtSet].Name, tmp);
						SetExtSetToDialog(hDlg, TmpExtSetTbl, tmpCurExtSet);
						SetExtSetHide(hDlg, tmpCurExtSet);
					}
					break;

				case EXT_RENAME :
					_tcscpy(tmp, TmpExtSetTbl[tmpCurExtSet].Name);
					if(InputDialogBox(newset_dlg, hDlg, MSGJPN_29, tmp, EXT_NAME_LEN+1, &i) == YES)
					{
						_tcscpy(TmpExtSetTbl[tmpCurExtSet].Name, tmp);
						SetExtSetToDialog(hDlg, TmpExtSetTbl, tmpCurExtSet);

						SendDlgItemMessage(hDlg, EXT_NAME, CB_INSERTSTRING, tmpCurExtSet, (LPARAM)tmp);
						SendDlgItemMessage(hDlg, EXT_NAME, CB_DELETESTRING, tmpCurExtSet+1, 0);
						SendDlgItemMessage(hDlg, EXT_NAME, CB_SETCURSEL, tmpCurExtSet, 0);
					}
					break;

				case EXT_DEL :
					if(DialogBox(GetProgInst(), MAKEINTRESOURCE(delset_notify_dlg), hDlg, ExeEscDialogProc) == YES)
					{
						memmove(&TmpExtSetTbl[tmpCurExtSet], 
								&TmpExtSetTbl[tmpCurExtSet+1],
								(char*)&TmpExtSetTbl[TmpExtSetNum] - (char*)&TmpExtSetTbl[tmpCurExtSet+1]);
						TmpExtSetNum--;
						SendDlgItemMessage(hDlg, EXT_NAME, CB_DELETESTRING, tmpCurExtSet, 0);
						tmpCurExtSet = 0;
						SendDlgItemMessage(hDlg, EXT_NAME, CB_SETCURSEL, tmpCurExtSet, 0);
						SetExtSetToDialog(hDlg, TmpExtSetTbl, tmpCurExtSet);
						SetExtSetHide(hDlg, tmpCurExtSet);
					}
					break;

				case IDOK :
					GetExtSetFromDialog(hDlg, TmpExtSetTbl, tmpCurExtSet);
					for(i = 0; i < PROP_PAGES; i++)
					{
						pnmhdr.code = PSN_APPLY;
						SendMessage(SheetInfo[i].hWndSheet, WM_NOTIFY, 0, (LPARAM)&pnmhdr);
						EndDialog(SheetInfo[i].hWndSheet, YES);
					}
					free(GlobalSet.ExtSetTbl);
					GlobalSet.ExtSetTbl = TmpExtSetTbl;
					GlobalSet.ExtSetNum = TmpExtSetNum;
					GlobalSet.ExtSetMax = TmpExtSetMax;
					EndDialog(hDlg, YES);
					break;

				case IDCANCEL :
					for(i = 0; i < PROP_PAGES; i++)
					{
						EndDialog(SheetInfo[i].hWndSheet, NO);
					}
					free(TmpExtSetTbl);
					EndDialog(hDlg, NO);
					break;

				case IDHELP :
					hWndHelp = HtmlHelp(NULL, AskHelpFilePath(), HH_HELP_CONTEXT, SheetInfo[curPage].HelpId);
					break;
			}
			return(TRUE);
    }
	return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :	SetExtSetToDialog
Desc    :	t@C^Cvʐݒ_CAOɑ
Param   :	hDlg	EChEnh
			tbl		ݒe[u
			num		ݒԍ
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void SetExtSetToDialog(HWND hDlg, EXTSET *tbl, int num)
{
	LPTSTR	pos;

	tbl += num;

	/****** Page 1 ******/
 	SendDlgItemMessage(SheetInfo[0].hWndSheet, EXT_EXTIN, WM_SETTEXT, 0, (LPARAM)_T(""));
	SendDlgItemMessage(SheetInfo[0].hWndSheet, EXT_EXTLIST, LB_RESETCONTENT, 0, 0);
	pos = tbl->Exts;
	while(*pos != NUL)
	{
		SendDlgItemMessage(SheetInfo[0].hWndSheet, EXT_EXTLIST, LB_ADDSTRING, 0, (LPARAM)pos);
		pos += _tcslen(pos) + 1;
	}

	/****** Page 2 ******/
	SetDecimalText(SheetInfo[1].hWndSheet, EXT_TAB, tbl->TabWidth);
	SetDecimalText(SheetInfo[1].hWndSheet, EXT_FOLD, tbl->FoldPos);
	SetDecimalText(SheetInfo[1].hWndSheet, EXT_LINESPC, tbl->LineSpace);
	SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_CRMARK, BM_SETCHECK, tbl->CrMark, 0);
	SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_TABMARK, BM_SETCHECK, tbl->TabMark, 0);
	SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_HANSPCMARK, BM_SETCHECK, tbl->HanSpcMark, 0);
	SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_ZENSPCMARK, BM_SETCHECK, tbl->ZenSpcMark, 0);

	TmpTextColor   = tbl->TextColor;
	TmpHighColor   = tbl->HighColor;
	TmpBackColor   = tbl->BackColor;
	TmpCtrlColor   = tbl->CtrlColor;
	TmpFindColor   = tbl->FindColor;
	TmpCrColor     = tbl->CrColor;
	TmpTabColor    = tbl->TabColor;
	TmpHanSpcColor = tbl->HanSpcColor;
	TmpZenSpcColor = tbl->ZenSpcColor;

	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_TEXTCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_HIGHCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_BACKCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_FINDCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_CTRLCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_CRCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_TABCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_HANSPCCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(SheetInfo[1].hWndSheet, EXT_ZENSPCCOLOR), NULL, TRUE);

	SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_LINENUM, BM_SETCHECK, tbl->LineNumDisp, 0);
	SetRadioButtonByValue(SheetInfo[1].hWndSheet, tbl->LineNumType, LineNumButton, LINENUMBUTTONS);

	SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_FOLDRIGHT, BM_SETCHECK, tbl->FoldRight, 0);
	if(tbl->FoldRight == YES)
	{
		EnableWindow(GetDlgItem(SheetInfo[1].hWndSheet, EXT_FOLD), FALSE);
		EnableWindow(GetDlgItem(SheetInfo[1].hWndSheet, EXT_FOLD_SPN), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(SheetInfo[1].hWndSheet, EXT_FOLD), TRUE);
		EnableWindow(GetDlgItem(SheetInfo[1].hWndSheet, EXT_FOLD_SPN), TRUE);
	}

	memcpy(&TmpLogFont, &tbl->Font, sizeof(LOGFONT));
	SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_FONT, WM_SETTEXT, 0, (LPARAM)tbl->Font.lfFaceName);

	/****** Page 3 ******/
	SetRadioButtonByValue(SheetInfo[2].hWndSheet, tbl->ToolType, ToolTypeButton, TOOLTYPEBUTTONS);
	if(tbl->ToolType == TOOL_TYPE_ASSOC)
	{
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_EDITOR), FALSE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_EUC), FALSE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_JIS), FALSE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_SJIS), FALSE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_UTF16), FALSE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_UTF16_BE), FALSE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_UTF8), FALSE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_UTF7), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_EDITOR), TRUE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_EUC), TRUE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_JIS), TRUE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_SJIS), TRUE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_UTF16), TRUE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_UTF16_BE), TRUE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_UTF8), TRUE);
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_UTF7), TRUE);
	}

	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_EDITOR, WM_SETTEXT, 0, (LPARAM)tbl->EditorName);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_EUC, WM_SETTEXT, 0, (LPARAM)tbl->EditOptEUC);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_JIS, WM_SETTEXT, 0, (LPARAM)tbl->EditOptJIS);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_SJIS, WM_SETTEXT, 0, (LPARAM)tbl->EditOptSJIS);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_UTF16, WM_SETTEXT, 0, (LPARAM)tbl->EditOptUTF16);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_UTF16_BE, WM_SETTEXT, 0, (LPARAM)tbl->EditOptUTF16BE);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_UTF8, WM_SETTEXT, 0, (LPARAM)tbl->EditOptUTF8);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_UTF7, WM_SETTEXT, 0, (LPARAM)tbl->EditOptUTF7);


	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_EDITCLOSE, BM_SETCHECK, tbl->EditAndClose, 0);
	if(tbl->EditAndClose == YES)
	{
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_EDITRELOAD), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(SheetInfo[2].hWndSheet, TOOL_EDITRELOAD), TRUE);
	}

	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_EDITRELOAD, BM_SETCHECK, tbl->EditAutoReLoad, 0);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetExtSetFromDialog
Desc    :	t@C^Cvʐݒ_CAO󂯎
Param   :	hDlg	EChEnh
			tbl		[out] ݒe[u
			num		ݒԍ
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void GetExtSetFromDialog(HWND hDlg, EXTSET *tbl, int num)
{
	int		i;
	_TCHAR	tmp[EXT_EXT_LEN+1];

	tbl += num;

	/****** Page 1 ******/
	memset(tbl->Exts, NUL, EXT_EXT_LEN);
	num = SendDlgItemMessage(SheetInfo[0].hWndSheet, EXT_EXTLIST, LB_GETCOUNT, 0, 0);
	for(i = 0; i < num; i++)
	{
		SendDlgItemMessage(SheetInfo[0].hWndSheet, EXT_EXTLIST, LB_GETTEXT, i, (LPARAM)tmp);
		_tcscpy(tbl->Exts + AskMultiStrLen(tbl->Exts), tmp);
	}

	/****** Page 2 ******/
	tbl->TabWidth = GetDecimalText(SheetInfo[1].hWndSheet, EXT_TAB);
	CheckRange2(&tbl->TabWidth, 16, 2);
	tbl->FoldPos = GetDecimalText(SheetInfo[1].hWndSheet, EXT_FOLD);
	CheckRange2(&tbl->FoldPos, 260, 5);
	tbl->LineSpace = GetDecimalText(SheetInfo[1].hWndSheet, EXT_LINESPC);
	CheckRange2(&tbl->LineSpace, 99, 0);
	tbl->CrMark = SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_CRMARK, BM_GETCHECK, 0, 0);
	tbl->TabMark = SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_TABMARK, BM_GETCHECK, 0, 0);
	tbl->HanSpcMark = SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_HANSPCMARK, BM_GETCHECK, 0, 0);
	tbl->ZenSpcMark = SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_ZENSPCMARK, BM_GETCHECK, 0, 0);

	tbl->TextColor   = TmpTextColor;
	tbl->HighColor   = TmpHighColor;
	tbl->BackColor   = TmpBackColor;
	tbl->FindColor   = TmpFindColor;
	tbl->CtrlColor   = TmpCtrlColor;
	tbl->CrColor     = TmpCrColor;
	tbl->TabColor    = TmpTabColor;
	tbl->HanSpcColor = TmpHanSpcColor;
	tbl->ZenSpcColor = TmpZenSpcColor;

	tbl->LineNumDisp = SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_LINENUM, BM_GETCHECK, 0, 0);
	tbl->LineNumType = AskRadioButtonValue(SheetInfo[1].hWndSheet, LineNumButton, LINENUMBUTTONS);

	tbl->FoldRight = SendDlgItemMessage(SheetInfo[1].hWndSheet, EXT_FOLDRIGHT, BM_GETCHECK, 0, 0);

	memcpy(&tbl->Font, &TmpLogFont, sizeof(LOGFONT));

	/****** Page 3 ******/
	tbl->ToolType = AskRadioButtonValue(SheetInfo[2].hWndSheet, ToolTypeButton, TOOLTYPEBUTTONS);

	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_EDITOR, WM_GETTEXT, MAX_PATH+1, (LPARAM)tbl->EditorName);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_EUC, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)tbl->EditOptEUC);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_JIS, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)tbl->EditOptJIS);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_SJIS, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)tbl->EditOptSJIS);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_UTF16, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)tbl->EditOptUTF16);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_UTF16_BE, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)tbl->EditOptUTF16BE);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_UTF8, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)tbl->EditOptUTF8);
	SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_UTF7, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)tbl->EditOptUTF7);

	tbl->EditAndClose = SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_EDITCLOSE, BM_GETCHECK, 0, 0);
	tbl->EditAutoReLoad = SendDlgItemMessage(SheetInfo[2].hWndSheet, TOOL_EDITRELOAD, BM_GETCHECK, 0, 0);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	SetExtSetHide
Desc    :	t@C^Cvʐݒ_CAÕnCh
Param   :	hDlg	EChEnh
			num		ݒԍ
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void SetExtSetHide(HWND hDlg, int num)
{
	int		show;
	BOOL	enable;
	LPTSTR	label;

	show = SW_SHOW;
	enable = TRUE;
	label = MSGJPN_30;
	if(num == 0)
	{
		show = SW_HIDE;
		enable = FALSE;
		label = MSGJPN_31;
	}

	ShowWindow(GetDlgItem(SheetInfo[0].hWndSheet, EXT_DEL), show);
	ShowWindow(GetDlgItem(SheetInfo[0].hWndSheet, EXT_EXTIN), show);
	ShowWindow(GetDlgItem(SheetInfo[0].hWndSheet, EXT_EXTLIST), show);
	ShowWindow(GetDlgItem(SheetInfo[0].hWndSheet, EXT_EXTADD), show);
	ShowWindow(GetDlgItem(SheetInfo[0].hWndSheet, EXT_EXTDEL), show);
	ShowWindow(GetDlgItem(SheetInfo[0].hWndSheet, EXT_FILELIST_EXAMPLE), show);

	SetWindowText(GetDlgItem(SheetInfo[0].hWndSheet, EXT_FILELIST_TEXT), label);

	EnableWindow(GetDlgItem(hDlg, EXT_RENAME), enable);
	EnableWindow(GetDlgItem(hDlg, EXT_DEL), enable);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	SetDecimalText
Desc    :	_CAÕRg[ɂPOiZbg
Param   :	hDlg	EChEnh
			ctrl	Rg[ID
			num		l
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void SetDecimalText(HWND hDlg, int ctrl, int num)
{
	_TCHAR	tmp[40];

	_stprintf(tmp, _T("%d"), num);
	SendDlgItemMessage(hDlg, ctrl, WM_SETTEXT, 0, (LPARAM)tmp);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetDecimalText
Desc    :	_CAÕRg[POi擾
Param   :	hDlg	EChEnh
			ctrl	Rg[ID
Return  :	l
Note    :	
-------------------------------------------------------------------------------*/
static int GetDecimalText(HWND hDlg, int ctrl)
{
	_TCHAR	tmp[40];

	SendDlgItemMessage(hDlg, ctrl, WM_GETTEXT, (WPARAM)39, (LPARAM)tmp);
	return(_ttoi(tmp));
}


/*-------------------------------------------------------------------------------
Name    :	FnameSettingProc
Desc    :	t@CݒEChẼbZ[W
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	LRESULT
Note    :	
-------------------------------------------------------------------------------*/
static LRESULT CALLBACK FnameSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR	*pnmhdr;
	_TCHAR	tmp[EXT_EXT_LEN+1];
	_TCHAR	tmp2[EXT_EXT_LEN+1];
	int		len;
	int		i;
	int		num;

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, EXT_TAB, EM_LIMITTEXT, (WPARAM)2, 0);
			SendDlgItemMessage(hDlg, EXT_TAB_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(16, 2));
			SendDlgItemMessage(hDlg, EXT_FOLD, EM_LIMITTEXT, (WPARAM)3, 0);
			SendDlgItemMessage(hDlg, EXT_FOLD_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(260, 5));
			SendDlgItemMessage(hDlg, EXT_LINESPC, EM_LIMITTEXT, (WPARAM)2, 0);
			SendDlgItemMessage(hDlg, EXT_LINESPC_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(99, 0));
			return(TRUE);

		case WM_NOTIFY:
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					break;
			}
			break;

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case EXT_EXTADD :
					_tcscpy(tmp, _T(""));
					if(InputDialogBox(fname_in_dlg, hDlg, MSGJPN_0, tmp, EXT_EXT_LEN, &i) == YES)
					{
						len = _tcslen(tmp);
						if(len > 0)
						{
							len++;
							num = SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_GETCOUNT, 0, 0);
							for(i = 0; i < num; i++)
							{
								SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_GETTEXT, i, (LPARAM)tmp2);
								len += _tcslen(tmp2) + 1;
							}

							if(len > EXT_EXT_LEN)
							{
								MessageBeep(-1);
							}
							else
							{
								SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_ADDSTRING, 0, (LPARAM)tmp);
								SendDlgItemMessage(hDlg, EXT_EXTIN, WM_SETTEXT, 0, (LPARAM)_T(""));
							}
						}
					}
					break;

				case EXT_EXTDEL :
					if((i = SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_GETCURSEL, 0, 0)) != LB_ERR)
					{
						SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_DELETESTRING, i, 0);
					}
					break;
			}
			break;
	}
    return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :	ColorSettingProc
Desc    :	\ݒEChẼbZ[W
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	LRESULT
Note    :	
-------------------------------------------------------------------------------*/
static LRESULT CALLBACK ColorSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR		*pnmhdr;
	CHOOSEFONT	cFont;
	LOGFONT		tmpFont;

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, EXT_TAB, EM_LIMITTEXT, (WPARAM)2, 0);
			SendDlgItemMessage(hDlg, EXT_TAB_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(16, 2));
			SendDlgItemMessage(hDlg, EXT_FOLD, EM_LIMITTEXT, (WPARAM)3, 0);
			SendDlgItemMessage(hDlg, EXT_FOLD_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(260, 5));
			SendDlgItemMessage(hDlg, EXT_LINESPC, EM_LIMITTEXT, (WPARAM)2, 0);
			SendDlgItemMessage(hDlg, EXT_LINESPC_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(99, 0));
			return(TRUE);

		case WM_NOTIFY:
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					break;
			}
			break;

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case EXT_TEXTCOLOR :
					if(SelectColor(hDlg, &TmpTextColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_TEXTCOLOR), NULL, FALSE);
					}
					break;

				case EXT_HIGHCOLOR :
					if(SelectColor(hDlg, &TmpHighColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_HIGHCOLOR), NULL, FALSE);
					}
					break;

				case EXT_BACKCOLOR :
					if(SelectColor(hDlg, &TmpBackColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_BACKCOLOR), NULL, FALSE);
					}
					break;

				case EXT_FINDCOLOR :
					if(SelectColor(hDlg, &TmpFindColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_FINDCOLOR), NULL, FALSE);
					}
					break;

				case EXT_CTRLCOLOR :
					if(SelectColor(hDlg, &TmpCtrlColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_CTRLCOLOR), NULL, FALSE);
					}
					break;

				case EXT_CRCOLOR :
					if(SelectColor(hDlg, &TmpCrColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_CRCOLOR), NULL, FALSE);
					}
					break;

				case EXT_TABCOLOR :
					if(SelectColor(hDlg, &TmpTabColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_TABCOLOR), NULL, FALSE);
					}
					break;

				case EXT_HANSPCCOLOR :
					if(SelectColor(hDlg, &TmpHanSpcColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_HANSPCCOLOR), NULL, FALSE);
					}
					break;

				case EXT_ZENSPCCOLOR :
					if(SelectColor(hDlg, &TmpZenSpcColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
					{
						InvalidateRgn(GetDlgItem(hDlg, EXT_ZENSPCCOLOR), NULL, FALSE);
					}
					break;

				case EXT_FOLDRIGHT :
					if(SendDlgItemMessage(hDlg, EXT_FOLDRIGHT, BM_GETCHECK, 0, 0) == 1)
					{
						EnableWindow(GetDlgItem(hDlg, EXT_FOLD), FALSE);
						EnableWindow(GetDlgItem(hDlg, EXT_FOLD_SPN), FALSE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg, EXT_FOLD), TRUE);
						EnableWindow(GetDlgItem(hDlg, EXT_FOLD_SPN), TRUE);
					}
					break;

				case EXT_FONT_BR :
					memcpy(&tmpFont, &TmpLogFont, sizeof(LOGFONT));
					cFont.lStructSize = sizeof(CHOOSEFONT);
					cFont.hwndOwner = hDlg;
					cFont.lpLogFont = &tmpFont;
					cFont.Flags = CF_FORCEFONTEXIST | CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;
					cFont.nFontType = SCREEN_FONTTYPE;
					if(ChooseFont(&cFont) == TRUE)
					{
						memcpy(&TmpLogFont, &tmpFont, sizeof(LOGFONT));
						SendDlgItemMessage(hDlg, EXT_FONT, WM_SETTEXT, 0, (LPARAM)TmpLogFont.lfFaceName);
					}
					break;
			}
			return(TRUE);

		case WM_DRAWITEM :
			switch(wParam)
			{
				case EXT_TEXTCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpTextColor);
					break;

				case EXT_HIGHCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpHighColor);
					break;

				case EXT_BACKCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpBackColor);
					break;

				case EXT_FINDCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpFindColor);
					break;

				case EXT_CTRLCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpCtrlColor);
					break;

				case EXT_CRCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpCrColor);
					break;

				case EXT_TABCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpTabColor);
					break;

				case EXT_HANSPCCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpHanSpcColor);
					break;

				case EXT_ZENSPCCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpZenSpcColor);
					break;
			}
			return(TRUE);
	}
    return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :	SelectColor
Desc    :	FĨR_CAOЂ炭
Param   :	hWnd		EChEnh
			color		[out] F
			tbl			ݒe[u
			num			ݒ̌
Return  :	Xe[^X (TRUE/FALSE=)
Note    :	
-------------------------------------------------------------------------------*/
static int SelectColor(HWND hWnd, COLORREF *color, EXTSET *tbl, int num)
{
	CHOOSECOLOR	cColor;
	COLORREF	cust[16];
	BOOL		Sts;
	int			i;
	int			j;

	memset(cust, 0, 16 * sizeof(COLORREF));
	cust[0] = *color;
	j = 1;
	for(i = 0; i < num; i++)
	{
		j = SerDefinedColor(j, cust, tbl[i].TextColor);
		j = SerDefinedColor(j, cust, tbl[i].HighColor);
		j = SerDefinedColor(j, cust, tbl[i].CtrlColor);
		j = SerDefinedColor(j, cust, tbl[i].BackColor);
		j = SerDefinedColor(j, cust, tbl[i].FindColor);
	}

	cColor.lStructSize = sizeof(CHOOSECOLOR);
	cColor.hwndOwner = hWnd;
	cColor.hInstance = 0;
	cColor.rgbResult = *color;
	cColor.lpCustColors = cust;
	cColor.Flags = CC_RGBINIT | CC_FULLOPEN;

	if((Sts = ChooseColor(&cColor)) == TRUE)
	{
		*color = cColor.rgbResult;
	}

	return((int)Sts);
}


/*-------------------------------------------------------------------------------
Name    :	SerDefinedColor
Desc    :	VFe[uɓo^
Param   :	num		o^ԍ
			tbl		e[u
			color	o^F
Return  :	̓o^ԍ
Note    :	
-------------------------------------------------------------------------------*/
static int SerDefinedColor(int num, COLORREF *tbl, COLORREF color)
{
	int		i;

	if(num < 16)
	{
		for(i = 1; i < num; i++)
		{
			if(tbl[i] == color)
			{
				break;
			}
		}
		if(i == num)
		{
			tbl[num++] = color;
		}
	}
	return(num);
}


/*-------------------------------------------------------------------------------
Name    :	DrawColorButton
Desc    :	J[{^`
Param   :	dItem	I[i[h[{^̕`\
			color	{^\ʂ̐F
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void DrawColorButton(DRAWITEMSTRUCT *dItem, COLORREF color)
{
	HPEN	hPenSave;
	HBRUSH	hBrush;
	HBRUSH	hBrushSave;

	hPenSave = SelectObject(dItem->hDC, GetStockObject(BLACK_PEN));
	hBrush = CreateSolidBrush(color);
	hBrushSave = SelectObject(dItem->hDC, hBrush);

	Rectangle(dItem->hDC, dItem->rcItem.left, dItem->rcItem.top, dItem->rcItem.right, dItem->rcItem.bottom);

	MoveToEx(dItem->hDC, dItem->rcItem.left+1, dItem->rcItem.bottom-2, NULL);
	LineTo(dItem->hDC, dItem->rcItem.right-2, dItem->rcItem.bottom-2);
	LineTo(dItem->hDC, dItem->rcItem.right-2, dItem->rcItem.top+1);

	SelectObject(dItem->hDC, GetStockObject(WHITE_PEN));
	MoveToEx(dItem->hDC, dItem->rcItem.left, dItem->rcItem.bottom-1, NULL);
	LineTo(dItem->hDC, dItem->rcItem.left, dItem->rcItem.top);
	LineTo(dItem->hDC, dItem->rcItem.right-1, dItem->rcItem.top);

	MoveToEx(dItem->hDC, dItem->rcItem.left+1, dItem->rcItem.bottom-2, NULL);
	LineTo(dItem->hDC, dItem->rcItem.left+1, dItem->rcItem.top+1);
	LineTo(dItem->hDC, dItem->rcItem.right-2, dItem->rcItem.top+1);

	SelectObject(dItem->hDC, hPenSave);
	SelectObject(dItem->hDC, hBrushSave);
	DeleteObject(hBrush);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	ToolSettingProc
Desc    :	c[ݒEChẼbZ[W
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	LRESULT
Note    :	
-------------------------------------------------------------------------------*/
static LRESULT CALLBACK ToolSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR	*pnmhdr;
	_TCHAR	tmp[MAX_PATH+1];

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, TOOL_EDITOR, EM_LIMITTEXT, MAX_PATH-EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_EUC, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_JIS, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_SJIS, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_UTF16, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_UTF16_BE, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_UTF8, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_UTF7, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			return(TRUE);

		case WM_NOTIFY:
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					break;
			}
			break;

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case TOOL_EDITOR_BR :
					_tcscpy(tmp, _T(""));
					if(SelectFileToOpen(hDlg, tmp, MSGJPN_32, MSGJPN_33, _T("")) == TRUE)
					{
						SendDlgItemMessage(hDlg, TOOL_EDITOR, WM_SETTEXT, 0, (LPARAM)tmp);
					}
					break;

				case TOOL_EDITCLOSE :
					if(SendDlgItemMessage(hDlg, TOOL_EDITCLOSE, BM_GETCHECK, 0, 0) == 1)
					{
						EnableWindow(GetDlgItem(hDlg, TOOL_EDITRELOAD), FALSE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg, TOOL_EDITRELOAD), TRUE);
					}
					break;

				case TOOL_ASSOC :
					EnableWindow(GetDlgItem(hDlg, TOOL_EDITOR), FALSE);
					EnableWindow(GetDlgItem(hDlg, TOOL_EUC), FALSE);
					EnableWindow(GetDlgItem(hDlg, TOOL_JIS), FALSE);
					EnableWindow(GetDlgItem(hDlg, TOOL_SJIS), FALSE);
					EnableWindow(GetDlgItem(hDlg, TOOL_UTF16), FALSE);
					EnableWindow(GetDlgItem(hDlg, TOOL_UTF16_BE), FALSE);
					EnableWindow(GetDlgItem(hDlg, TOOL_UTF8), FALSE);
					EnableWindow(GetDlgItem(hDlg, TOOL_UTF7), FALSE);
					break;

				case TOOL_SPECIFIED :
					EnableWindow(GetDlgItem(hDlg, TOOL_EDITOR), TRUE);
					EnableWindow(GetDlgItem(hDlg, TOOL_EUC), TRUE);
					EnableWindow(GetDlgItem(hDlg, TOOL_JIS), TRUE);
					EnableWindow(GetDlgItem(hDlg, TOOL_SJIS), TRUE);
					EnableWindow(GetDlgItem(hDlg, TOOL_UTF16), TRUE);
					EnableWindow(GetDlgItem(hDlg, TOOL_UTF16_BE), TRUE);
					EnableWindow(GetDlgItem(hDlg, TOOL_UTF8), TRUE);
					EnableWindow(GetDlgItem(hDlg, TOOL_UTF7), TRUE);
					break;
			}
			return(TRUE);
	}
    return(FALSE);
}


